//#include <netdb.h>
//#include <linux/cdrom.h>
//#include <linux/ioctl.h>
#include <assert.h>
#include "sope.h"
#include "hwr.h"
#include "cdrom.h"

#define CDDEVICE "/dev/cdrom"

uint8 cdIoStatus;
uint8 cdStatus;
uint8 cdMode;
uint8 cdParam[8];
uint8 cdResult[8];
uint8 cdLocation[4];
int cdParamP;
int cdResultC;
int cdResultP;
int cdResultReady;
int cdEnterParam;
int cdReaded=-1;

char *cd_funcname[0x100]={
						"Sync","Nop","SetLoc","Play","Forward","Backward","ReadN","Standby",
						"Stop","Pause","Init","Mute","Demute","Setfilter","Setmode","Getparam",
						"GetlocL","GetlocP","","GetTN","GetTD","SeekL","SeekP","",
						"","Test","ID","ReadS","Reset","","ReadTOC","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","","",
						"","","","","","","","","","","","","","","",""};

void cddma() {
	ciao("CDDMA...");
}

void cd_misc() {
	if (cdResultReady && cdResultC) {
		cdIoStatus|=0x20;
		HRM(cd_reg1)=cdResult[cdResultP];
	}
	else  cdIoStatus&=0xdf;
	/**/
	if (!(cdResultReady && cdResultC)) {
		cdResultP = 0;
		cdResultC = 1;
		cdResult[0] = 0;
		cdStatus = 4;
		cdResultReady=1;
		HRM(i_reg)|=4;
	}
		

}

uint8 cdrom_read_reg0(){
	printf("read cd_reg0\n");
	if (cdReaded==0) return(cdIoStatus | 0x40);
	return(cdIoStatus);	
}

uint8 cdrom_read_reg1(){
	printf("read cd_reg1\n");
	if (cdResultReady) {
		cdResultP++;
		if (cdResultP==cdResultC) cdResultReady = 0;
		cd_misc();
	}
	return(HRM(cd_reg1));
}

uint8 cdrom_read_reg2(){
	assert(0);
}

uint8 cdrom_read_reg3(){
	printf("read cd_reg3\n");
	return(cdStatus);
}

void cdrom_write_reg0(uint8 c){
	printf("written 0x%2.2x to cd_reg0\n",c);
	if ((c&1)==1) {cdResultReady=1;cd_misc();}
	if ((c&1)==0) {cdEnterParam=1;}
	return;
}

void cdrom_write_reg2(uint8 c){
	printf("written 0x%2.2x to cd_reg2\n",c);
	if  ((c==7) && (cdEnterParam==0)) {
		cdParamP=0;
		cdStatus=0;
	} else {
		cdParam[cdParamP++]=c;
		if (cdParamP>7) ciao("CD param buffer overflow");
	}
}   

void cdrom_write_reg3(uint8 c){
	printf("written 0x%2.2x to cd_reg3\n",c);
	if (c==7) cdStatus=0;
}   


void cdrom_write_reg1(uint8 c) {
int i;

printf("# Sope # CD-ROM command: %s ",cd_funcname[c]);

switch(c) {
case 0x00:
case 0x01:	/*Nop:		Does nothing , except return status*/
case 0x09:	/*Pause:	Pause at current location*/
case 0x0b:	/*Mute audio playback*/
case 0x0c:	/*Unmute audio playback*/	
			cdResultP = 0;
			cdResultC = 1;
			cdResult[0] = 0x2;
			cdStatus = 2;
			break;
case 0x02:	/*Sets the location for any play and seek operation*/
			for(i=0;i<3;i++) cdLocation[i] = cdParam[i];
			printf("(set to %u min, %u sec, sector %u)",cdLocation[0],cdLocation[1],cdLocation[2]);
			cdLocation[3]=0;
			cdResultP = 0;
			cdResultC = 1;
			cdResult[0] = 0;
			cdStatus = 3;
			break;
case 0x03:	/*Starts audio playback*/
			/*displayCL(0x44);
			dcdPlay(cdSetSector);
			displayCL(0x00);*/
			cdResultP = 0;
			cdResultC = 1;
			cdResult[0] = 0x80;
			cdStatus = 2;
			break;
case 0x06:	/*ReadN: Read with retry*/
			cdResultP = 0;
			cdResultC = 1;
			cdResult[0] = 2;
			cdStatus = 2;
			cdResultReady=1;
			cdReaded=0;
//			cdIoStatus=2;
			break;
case 0x0a:	/*Init:		Multiple effects at once.  Setmode = 00, Standby, abort
						all commands.*/
			cdResultP=0;
			cdResultC=1;
			cdResult[0]=0x2;
			cdStatus=2;
			cdMode=0;
			break;
case 0x0e:	/*Setmode:	Sets parameters such as read mode and spin speed.*/
			cdMode = cdParam[0];
			printf("(set to %x)",cdMode);
			cdResultP = 0;
			cdResultC = 1;
			cdResult[0] = 0;
			cdStatus = 2;
			break;
case 0x13:	
//			dcdGetTN(cdResultTN);
	   		cdResultP = 0;
			cdResultC = 3;
			cdResult[0] = 0;
//			cdResult[1] = doBCD(cdResultTN[0]);
//			cdResult[2] = doBCD(cdResultTN[1]);
			cdStatus = 2;
			break;
case 0x14:	
//			cdTrack = (cdParam[0]>>4)*10+(cdParam[0]&0xf);
//			dcdGetTD(cdTrack+1, cdResultTD);
			cdResultP = 0;
			cdResultC = 4;
			cdResult[0] = 0;
//			cdResult[1] = doBCD(cdResultTD[1]);
//			cdResult[2] = doBCD(cdResultTD[2]);
//			cdResult[3] = doBCD(cdResultTD[3]);
			cdStatus = 2;
			break;
}

if (cd_funcname[c]=="") printf("no 0x%2.2x not yet implemented",c);
else {cdint_enable=1;ctx.nstp=0x10000;}
cdResultReady=1;
cdEnterParam=0;
printf("\n");
}

