#include "sope.h"
#define v0 ctx.gpr[2]
#define a0 ctx.gpr[4]
#define a1 ctx.gpr[5]
#define a2 ctx.gpr[6]
#define a3 ctx.gpr[7]
#define Ra0 ((char *)&getopc(a0))
#define Ra1 ((char *)&getopc(a1))
#define Ra2 ((char *)&getopc(a2))
#define Ra3 ((char *)&getopc(a3))


void syscall_a0(uint32 arg) {
     switch(arg) {
     case 0x01: /*lseek*/
             v0=read(a0,a1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x02: /*read*/
             v0=read(a0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x03: /*write*/
             v0=read(a0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x04: /*close*/
             v0=close(a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x06: /*exit*/
             ciao("# Sope # Exit by System Call 0x06");
     case 0x10: /*atoi*/
             v0=atoi(Ra0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x11: /*atol*/
             v0=atol(Ra0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x1b: /*strlen*/
             v0=strlen(Ra0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x15: /*strcat*/
             v0=a0;
             strcat(Ra0,Ra1);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x16: /*strncmp*/
             v0=a0;
             strncat(Ra0,Ra1);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x17: /*strcmp*/
             v0=strcmp(Ra0,Ra1);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x18: /*strncmp*/
             v0=strncmp(Ra0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x19: /*strcpy*/
             v0=a0;
             strcpy(Ra0,Ra1);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x1a: /*strncpy*/
             v0=a0;
             strncpy(Ra0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x25: /*toupper*/
             v0=toupper(a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x26: /*tolower*/
             v0=tolower(a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x27: /*bcopy*/
             memcpy(Ra1,Ra0,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x28: /*bzero*/
             memset(Ra0,0,a1);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x2a: /*memcpy*/
             v0=a0;
             memcpy(Ra0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x2b: /*memset*/
             v0=a0;
             memset(Ra0,a1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x2c: /*memmove*/
             v0=a0;
             memmove(Ra0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x2d: /*memcmp*/
             v0=memcmp(Ra0,Ra1,a2);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x2f: /*rand*/
             v0=rand();
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x30: /*srand*/
             srand(a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x3d: /*puts*/
             v0=puts(Ra0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x3f: /*printf*/
             printf(Ra0,Ra1,Ra2,Ra3);/* Ra0 == "...", Ra1-Ra3 == ,...,*/
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x47: /*MEM2VRAM*/
             HRM32(0x10a8)=0x01000201;
             gpudma();
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x48: /*SendGPU*/
             gpufunc(a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x49: /*GPU_cw*/
             gp0write(a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x4e: /*GPU_sync*/
             enable_vsync=1;
             ctx.pc0=ctx.gpr[31];
             break;
     default:
           if (debug_syscall) printf("# Sope # Syscall A0_%2.2x\n",arg);
     }
}

void syscall_b0(uint32 arg) {
     switch(arg) {
     case 0x3d: printf("%c",a0);
             ctx.pc0=ctx.gpr[31];
             break;
     case 0x4f: printf("# Sope # CARD READ\n");
             break;
     case 0x0b: ctx.pc0=ctx.gpr[31];
             v0=1;
             break;
/*Quick and dirty Pad Hack*/
     case 0x12:
             pad_buf=a0&0x1fffff;
             pad_init=2;
             ctx.pbuf=pad_buf;
             break;
     case 0x15:
             pad_buf=a1&0x1fffff;
             pad_init=1;
             ctx.pbuf=pad_buf;
             break;
     default:
           if (debug_syscall) printf("# Sope # Syscall B0_%2.2x %8.8x %8.8x %8.8x\n",arg,a0,a1,a2);
     }
}

void syscall_c0(uint32 arg) {
     switch(arg) {
     default:
           if (debug_syscall) printf("# Sope # Syscall C0_%2.2x\n",arg);
     }
}
