#include <stdlib.h>
#include "sope.h"
#include "memio.h"

void r_div(char unsigned s, char unsigned t, char unsigned uns)
{
	div_t tt;
	if (ctx.gpr[t] == 0)
		ciao("Error: division by zero!");
	if (uns == 0) {
		tt = div(SR[s], SR[t]);
		*((sint32 *) & ctx.HI) = tt.rem;
		*((sint32 *) & ctx.LO) = tt.quot;
	}
	if (uns == 1) {
		ctx.HI = ctx.gpr[s] % ctx.gpr[t];
		ctx.LO = ctx.gpr[s] / ctx.gpr[t];
	}
}

void r_wrl(uint32 rl1, uint8 t, long param)
{
	uint32 rl2, rl3, dis, dis2;
	dis = 8 * (rl1 & 3);
	dis2 = 8 * ((rl1 & 3) + 1);
	switch (param) {
	case 0:
		rl2 = rm_32(rl1 & 0xfffffffc);
		rl2 <<= (24 - dis);
		ctx.gpr[t] &= (0xffffffff >> dis2);
		ctx.gpr[t] |= rl2;
		break;
	case 1:
		rl2 = rm_32(rl1 & 0xfffffffc);
		rl2 >>= dis;
		ctx.gpr[t] &= (0xffffffff - (0xffffffff >> (32 - dis)));
		ctx.gpr[t] |= rl2;
		break;
	case 2:
		rl3 = rm_32(rl1 & 0xfffffffc);
		rl2 = ctx.gpr[t];
		rl3 &= (0xffffffff - (0xffffffff >> dis2));
		rl2 >>= (24 - dis);
		rl3 |= rl2;
		wm_32(rl3, rl1 & 0xfffffffc);
		break;
	case 3:
		rl3 = rm_32(rl1 & 0xfffffffc);
		rl2 = ctx.gpr[t];
		rl3 &= (0xffffffff >> (32 - dis));
		rl2 <<= dis;
		rl3 |= rl2;
		wm_32(rl3, rl1 & 0xfffffffc);
		break;
	}
}
