#define IGNORE_OPC 1
#include "sope.h"
#undef IGNORE_OPC
#include "tables.h"

void dasm(uint32 addr)
{
uint32 opc;
int unsigned op,oq,func,addr1,addr2;
int unsigned dt;
char unsigned distemp0[64],distemp[128];

opc=getopc(addr);
oq=(opc >> 26);
func=opc&63;

switch(oq) {
case 0:op=64+func;break;
case 1:op=128+rt;break;
case 16:op=160+rs;break;
default:op=oq;break;
}

sprintf(distemp0," 0x%8.8x: %8.8x  ",addr,opc);
if (opc==0) sprintf(distemp,"nop");
else {
char unsigned distemp2[128];

dt=dttable[op];

if ((dt==2) | (dt==3))
addr2=addr+simm*4+4;

switch (dt)
    {
    case  1:addr1=((addr+4)&0xf0000000)+((opc << 2)& 0x0fffffff);
	    sprintf(distemp2,"%8.8x",addr1);break;
    case  2:sprintf(distemp2,"%s,%s,%8.8x",regnames[rt],regnames[rs],addr2);break;
    case  3:sprintf(distemp2,"%s,%8.8x",regnames[rs],addr2);break;
    case  4:sprintf(distemp2,"%s,%s,%4.4x",regnames[rt],regnames[rs],imm);break;
    case  5:sprintf(distemp2,"%s,%4.4x",regnames[rt],imm);break;
    case  6:sprintf(distemp2,"%s,%4.4x(%s)",regnames[rt],imm,regnames[rs]);break;
    case  7:sprintf(distemp2,"%s,%s,%u",regnames[rd],regnames[rt],re);break;
    case  8:sprintf(distemp2,"%s,%s,%s",regnames[rd],regnames[rt],regnames[rs]);break;
    case  9:sprintf(distemp2,"%s",regnames[rs]);break;
    case 10:sprintf(distemp2,"%s",regnames[rd]);break;
    case 11:sprintf(distemp2,"%s,%s",regnames[rs],regnames[rt]);break;
    case 12:sprintf(distemp2,"%s,%s,%s",regnames[rd],regnames[rs],regnames[rt]);break;
    case 13:sprintf(distemp2,"%s,%s",regnames[rt],cp0names[rd]);break;

    case 22:sprintf(distemp2,"%x",opc&0x1ffffff);break;
    case 55:sprintf(distemp2,":not yet");break;
    case 99:sprintf(distemp,"???????????");break;
    }
if (dt!=99)
sprintf (distemp,"%s %s",opnames[op],distemp2);
}
sprintf(distring,"%s %s",distemp0,distemp);
}


void dasm2()
{
uint32 opc;
int unsigned op,oq,func,addr1,addr2;
int unsigned dt;

opc=getopc(ctx.pc0);
oq=(opc >> 26);
func=opc&63;

switch(oq) {
case 0:op=64+func;break;
case 1:op=128+rt;break;
case 16:op=160+rs;break;
default:op=oq;break;
}

printf(" 0x%8.8x: %8.8x  ",ctx.pc0,opc);
if (opc==0) printf("nop");
else {
dt=dttable[op];

if ((dt==2) | (dt==3))
addr2=ctx.pc0+simm*4+4;

if (dt!=99)
printf ("%s ",opnames[op]);
switch (dt)
    {
    case  1:addr1=((ctx.pc0+4)&0xf0000000)+((opc << 2)& 0x0fffffff);
	    printf("%8.8x",addr1);break;
    case  2:printf("%8.8x(%s),%8.8x(%s),%8.8x",ctx.gpr[rt],regnames[rt],ctx.gpr[rs],regnames[rs],addr2);break;
    case  3:printf("%8.8x(%s),%8.8x",ctx.gpr[rs],regnames[rs],addr2);break;
    case  4:printf("%8.8x(%s),%8.8x(%s),%4.4x",ctx.gpr[rt],regnames[rt],ctx.gpr[rs],regnames[rs],imm);break;
    case  5:printf("%s:%8.8x",regnames[rt],imm<<16);break;
    case  6:printf("%s,%8.8x",regnames[rt],ctx.gpr[rs]+simm);break;
    case  7:printf("%s:%8.8x(%s),%u",regnames[rd],ctx.gpr[rt],regnames[rt],re);break;
    case  8:printf("%s:%8.8x(%s),%8.8x(%s)",regnames[rd],ctx.gpr[rt],regnames[rt],ctx.gpr[rs],regnames[rs]);break;
    case  9:printf("%8.8x(%s)",ctx.gpr[rs],regnames[rs]);break;
    case 10:printf("%8.8x(%s)",ctx.gpr[rd],regnames[rd]);break;
    case 11:printf("%8.8x(%s),%8.8x(%s)",ctx.gpr[rs],regnames[rs],ctx.gpr[rt],regnames[rt]);break;
    case 12:printf("%s,%8.8x(%s),%8.8x(%s)",regnames[rd],ctx.gpr[rs],regnames[rs],ctx.gpr[rt],regnames[rt]);break;
    case 13:printf("%8.8x(%s),%8.8x(%s)",ctx.gpr[rt],regnames[rt],ctx.cp0[rd],cp0names[rd]);break;

    case 22:printf("%x",opc&0x1ffffff);break;
    case 55:printf(":not yet");break;
    case 99:printf("???????????");break;
    }
}
printf ("\n");
}
