int unsigned n;
/*
R1-R2-R3: temporary registers
R4: CTX
R15-R30: 
*/

#define CTX (ptsize)&ctx

static inline uint32 real_cc() {
unsigned long cc;
asm volatile("rpcc %0" : "=r"(cc) : : "memory");
return cc;
}

uint32 cc_s;

#define axp_addl(i,j,k)  ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x00<<5)+(k))
#define axp_addq(i,j,k)  ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x20<<5)+(k))
#define axp_subl(i,j,k)  ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x09<<5)+(k))
#define axp_subq(i,j,k)  ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x29<<5)+(k))

#define axp_addq_i(i,j,k) ((0x10<<26)+((i)<<21)+((j)<<13)+0x1000+(0x20<<5)+(k))

#define axp_sextb(j,k)   ((0x1C<<26)+(31<<21)+((j)<<16)+	    (0x00<<5)+(k))
#define axp_sextw(j,k)   ((0x1C<<26)+(31<<21)+((j)<<16)+	    (0x01<<5)+(k))

#define axp_and(i,j,k)   ((0x11<<26)+((i)<<21)+((j)<<16)+	    (0x00<<5)+(k))
#define axp_bis(i,j,k)   ((0x11<<26)+((i)<<21)+((j)<<16)+       (0x20<<5)+(k))
#define axp_xor(i,j,k)   ((0x11<<26)+((i)<<21)+((j)<<16)+	    (0x40<<5)+(k))
#define axp_ornot(i,j,k) ((0x11<<26)+((i)<<21)+((j)<<16)+	    (0x28<<5)+(k))

#define axp_and_i(i,j,k) ((0x11<<26)+((i)<<21)+((j)<<13)+0x1000+(0x00<<5)+(k))
#define axp_bis_i(i,j,k) ((0x11<<26)+((i)<<21)+((j)<<13)+0x1000+(0x20<<5)+(k))
#define axp_xor_i(i,j,k) ((0x11<<26)+((i)<<21)+((j)<<13)+0x1000+(0x40<<5)+(k))

#define axp_srl(i,j,k)   ((0x12<<26)+((i)<<21)+((j)<<16)	   +(0x34<<5)+(k))
#define axp_sll(i,j,k)   ((0x12<<26)+((i)<<21)+((j)<<16)	   +(0x39<<5)+(k))
#define axp_sra(i,j,k)   ((0x12<<26)+((i)<<21)+((j)<<16)	   +(0x3C<<5)+(k))

#define axp_srl_i(i,j,k) ((0x12<<26)+((i)<<21)+((j)<<13)+0x1000+(0x34<<5)+(k))
#define axp_sll_i(i,j,k) ((0x12<<26)+((i)<<21)+((j)<<13)+0x1000+(0x39<<5)+(k))
#define axp_sra_i(i,j,k) ((0x12<<26)+((i)<<21)+((j)<<13)+0x1000+(0x3C<<5)+(k))

#define axp_zap_i(i,j,k) ((0x12<<26)+((i)<<21)+((j)<<13)+0x1000+(0x30<<5)+(k))

#define axp_extlh_i(i,j,k) ((0x12<<26)+((i)<<21)+((j)<<13)+0x1000+(0x6A<<5)+(k))
#define axp_extll_i(i,j,k) ((0x12<<26)+((i)<<21)+((j)<<13)+0x1000+(0x26<<5)+(k))

/*Computed Branch Instructions*/
#define axp_jmp(i,j)	 ((0x1A<<26)+((i)<<21)+((j)<<16)+(0<<14))
#define axp_jsr(i,j)	 ((0x1A<<26)+((i)<<21)+((j)<<16)+(1<<14))
#define axp_ret(i,j)	 ((0x1A<<26)+((i)<<21)+((j)<<16)+(2<<14))

/*Multiplication*/
#define axp_mulq(i,j,k)	 ((0x13<<26)+((i)<<21)+((j)<<16)+	    (0x20<<5)+(k))
/*Misc instructions*/
#define axp_mb	 	((0x18<<26)+0x4000)
#define axp_wmb	 	((0x18<<26)+0x4400)
#define axp_imb		0x86
#define axp_rpcc(i) ((0x18<<26)+((i)<<21)+0xC000)
#define axp_unop    ((0x0B<<26)+(31<<21)+(31<<16))
#define axp_fetch(i)	(((0x18<<26)+0x8000)+(i<<16))
#define axp_fetch_m(i)	(((0x18<<26)+0xA000)+(i<<16))

/*Memory Instructions*/
#define axp_ldbu(i,j,k)	 ((0x0A<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_ldwu(i,j,k)	 ((0x0C<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_ldl(i,j,k)	 ((0x28<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_ldq(i,j,k)	 ((0x29<<26)+((i)<<21)+((j)<<16)+(k))

#define axp_stb(i,j,k)	 ((0x0E<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_stw(i,j,k)	 ((0x0D<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_stl(i,j,k)	 ((0x2C<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_stq(i,j,k)	 ((0x2D<<26)+((i)<<21)+((j)<<16)+(k))

/*Branch Instructions*/
#define axp_bsr(i,k)	 ((0x34<<26)+((i)<<21)+((k)&0x1fffff))
#define axp_beq(i,k)	 ((0x39<<26)+((i)<<21)+((k)&0x1fffff))
#define axp_bne(i,k)	 ((0x3D<<26)+((i)<<21)+((k)&0x1fffff))

/*Compare Instructions*/
#define axp_cmpeq(i,j,k) ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x2D<<5)+(k))
#define axp_cmplt(i,j,k) ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x4D<<5)+(k))
#define axp_cmple(i,j,k) ((0x10<<26)+((i)<<21)+((j)<<16)+	    (0x6D<<5)+(k))

#define axp_lda(i,j,k)	((0x08<<26)+((i)<<21)+((j)<<16)+(k))
#define axp_ldah(i,j,k)	((0x09<<26)+((i)<<21)+((j)<<16)+(k))

ptsize bra_alpha[256];
uint32 bra_mips[256];
long bra_nb;

int pop_mips(uint32 *dest);
int push_mips(uint32 *dest);
void recompile_inst();
void recompile_block(uint32 addr);
void go_header(uint64 address);

#include "macros.h"
