#include "sope.h"
#include "machine.h"
#include "memio.h"
#include "gte.h"
#include "pad.h"
#include "hwr.h"
#include "gui.h"
#include "cpu_diff.h"
#include "../dyn_ops.h"

void test_wm(uint32 addr,uint32 what) {
	uint64 prout;
	if (((addr>>24)!=0x00) && ((addr>>24)!=0x80) && ((addr>>24)!=0xa0)) return;
	prout=alphad(addr);
	if (prout!=0) { printf("%8.8x Self-modifying code!!\n",addr);}
	if (addr==0xc80) alphad(addr)=0;
	if ((addr&0x1fffff)==0x500) alphad(addr)=0;
}

void (*ahead)();
uint32 *header_to;/*Points to where the destination has to be written*/

void make_header() {
	int p,m;
	p=0;
	header[p++]=axp_imb;
	m=load_adress(header+p,CTX,RC);p+=m;
//	header[p++]=axp_fetch_m(RC);
	SAVE_AXP_REGS
	header_to=header+p;
	for (m=0;m<15;m++) header[p++]=0xffffffff;
	m=pop_mips(header+p);p+=m;
	header[p++]=axp_jmp(31,1);
}

void go_header(uint64 address) {
	load_adress(header_to,address,1);
	ahead=(void *)header;
	(*ahead)();
}

void recompile_inst() {
	int i,j;
	uint64 diff1,diff2;
	long signed diff;

	for (i=(bra_nb-1);i>-1;i--) {
		if (_pc0==bra_mips[i]) {
			diff1=(uint64)alphaptr;
			diff2=(uint64)bra_alpha[i];
			diff=(diff1-diff2)/4-1;
			if ((abs(diff)>0xfffff)) {
				printf("# Sope # Error: %u branch is not yet supported\n",abs(diff));
				ciao("");
			}
			*(uint32 *)bra_alpha[i]=axp_bne(3,diff);
			for (j=i+1;j<bra_nb;j++) {
				bra_mips[j-1]=bra_mips[j];
				bra_alpha[j-1]=bra_alpha[j];
			}
			bra_nb--;
		}
	}
	opc=getopc(_pc0);
/*
  printf("doing %8.8x at %8.8x | remains",opc,_pc0);
  for (i=0;i<bra_nb;i++) printf(" %8.8x",bra_mips[i]);
  printf("\n");
*/
	alphaptr[n++]=axp_addq_i(RN,1,RN);
	if (_pc0==halt_address) byebye();
	dyn_normal[opc>>26]();
}
void recompile_block(uint32 addr) {

	_pc0=addr;
	stop_recompile=0;
	bra_nb=0;
	do {
		n=0;
//		if (alphad(_pc0)!=0) printf("# Sope # Hmm this has already been compiled...\n");
		alphad(_pc0)=(uint64)alphaptr;
		recompile_inst();
		alphaptr+=n;
		if ((((uint64)alphaptr-(uint64)alphacode)/4)>SIZE_DYN) ciao("too many instructions!!");
		_pc0+=4;
	} while (stop_recompile==0);
//printf("stopping at %8.8x\n",_pc0-4);
}

int load_adress(uint32 *dest,unsigned long am,int unsigned reg) {
	char unsigned c;
	int i;
	c=(am>>(8*7))&0xff;
	dest[0]=axp_bis_i(31,c,reg);
	for (i=1;i<8;i++) {
		c=(am>>(8*(7-i)))&0xff;
		dest[2*i-1]=axp_sll_i(reg,8,reg);
		dest[2*i]=axp_bis_i(reg,c,reg);
	}
	return(15);
}

int pop_mips(uint32 *dest) {
	int i,p;
	p=0;
	dest[p++]=axp_ldl(RN,RC,knstp);
	dest[p++]=axp_stq(30,RC,kstack);
	for (i=0;i<16;i++) dest[p++]=axp_ldq(15+i,RC,8*i);
	return(p);
}
int push_mips(uint32 *dest) {
	int i,p;
	p=0;
	for (i=0;i<16;i++) dest[p++]=axp_stq(15+i,RC,8*i);
	dest[p++]=axp_ldq(30,RC,kstack);
	dest[p++]=axp_stl(RN,RC,knstp);
	return(p);
}

void reset_dynarec() {
	long i;

	printf("Initialising dynarec core\n");
	ctx.hwr=(uint64)hwreg;
	ctx.hre=(uint64)hrreg;
	ctx.div=(uint64)r_div;
	ctx.wrl=(uint64)r_wrl;
	ctx.rm8u=(uint64)rm_8u;
	ctx.rm8s=(uint64)rm_8s;
	ctx.rm16u=(uint64)rm_16u;
	ctx.rm16s=(uint64)rm_16s;
	ctx.rm32=(uint64)rm_32;
	ctx.wm8=(uint64)wm_8;
	ctx.wm16=(uint64)wm_16;
	ctx.wm32=(uint64)wm_32;
	ctx.gtop=(uint64)gte_opcode;
	ctx.pad=(uint64)get_pad_buf;
	ctx.rc=(uint64)realcode;
	alphaptr=alphacode;
	for (i=0;i<0xA0000;i++) realcode[i]=0;
	for (i=0;i<0x10000;i++) mmp[i]=(uint64)CAC;
	for (i=0;i<0x80;i++) {
		mmp[0x0000+i]=(uint64)RAOM+0x10000*(i&0x1f);
		mmp[0x8000+i]=(uint64)RAOM+0x10000*(i&0x1f);
		mmp[0xa000+i]=(uint64)RAOM+0x10000*(i&0x1f);
	}
	for (i=0;i<8;i++) mmp[0xbfc0+i]=(uint64)RAOM+0x200000+0x10000*i;
	mmp[0x1f00]=(uint64)PAR;
	mmp[0x1f80]=(uint64)HRM;
	ctx.mptr=(uint64)mmp;
	ctx.test=(uint64)test_wm;
	make_header();
}
