int unsigned n;
//Temporary registers
#define EAX 0
#define ECX 1
#define EDX 2
#define EBX 3
//Cycle counter register
#define RN 6
//Context pointer register
#define RC 7
#include "dynrec.h"

#define CTX  (ptsize)&ctx
#define put_imm32(d,n1)	alphaptr[(n1)]=(d)&0xff;\
						alphaptr[(n1)+1]=((d)>>8)&0xff;\
						alphaptr[(n1)+2]=((d)>>16)&0xff;\
						alphaptr[(n1)+3]=((d)>>24)&0xff
#define simple_rr(o,i,j)	alphaptr[n++]=o;\
							alphaptr[n++]=0xC0+(j)+((i)<<3);

/*General instructions*/
#define int_pusha 	0x60
#define int_popa	0x61
#define int_ret		0xC3

/*Logical instructions*/
#define int_or	0x09
#define	int_xor	0x31
#define	int_and	0x21

#define m_log_rr(i,j,o)	simple_rr(o,i,j)

#define m_xor_rr(i,j)	m_log_rr(i,j,int_xor);

#define m_not_r(i)		alphaptr[n++]=0xF7;\
						alphaptr[n++]=0xC0+16+(i);

#define m_or_ri(i,d)	alphaptr[n++]=0x81;\
						alphaptr[n++]=0xC8+(i);\
						put_imm32(d,n);n+=4;
/*Comparison instructions*/
#define m_cmp_ali(e)	alphaptr[n++]=0x3C;\
						alphaptr[n++]=e;
#define m_cmp_rr(i,j)	simple_rr(0x3B,i,j)

/*Arithmetic instructions*/
#define	int_add		0x01
#define int_sub		0x29

#define m_add_rr(i,j)	simple_rr(int_add,i,j)
#define m_sub_rr(i,j)   simple_rr(int_sub,i,j)

#define m_add_ri(i,e)	alphaptr[n++]=0x81;\
						alphaptr[n++]=0xC0+(i);\
						put_imm32(e,n);n+=4;
#define m_sub_ri(i,e)   alphaptr[n++]=0x81;\
						alphaptr[n++]=0xE8+(i);\
						put_imm32(e,n);n+=4;

/*Move instructions*/
#define m_mov_from_ctx(i,d)	alphaptr[n++]=0x8B;\
							alphaptr[n++]=0x80+RC+((i)<<3);\
							put_imm32(d,n);n+=4;
#define m_mov_to_ctx(i,d)	alphaptr[n++]=0x89;\
							alphaptr[n++]=0x80+RC+((i)<<3);\
							put_imm32(d,n);n+=4;

#define m_mov_rm8(i,j,d)	alphaptr[n++]=0x88;\
						alphaptr[n++]=0x80+(j)+((i)<<3);\
						put_imm32(d,n);n+=4;
#define m_mov_rm(i,j)	alphaptr[n++]=0x89;\
						alphaptr[n++]=0x00+(j)+((i)<<3);
#define m_mov_mr(i,j)	alphaptr[n++]=0x8B;\
						alphaptr[n++]=0x00+(j)+((i)<<3);
#define m_mov_rr(i,j)	alphaptr[n++]=0x89;\
						alphaptr[n++]=0xC0+(j)+((i)<<3);
#define m_movsx_rr8(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xBE;\
							alphaptr[n++]=0xC0+(i)+((j)<<3);
#define m_movsx_rr16(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xBF;\
							alphaptr[n++]=0xC0+(i)+((j)<<3);
#define m_movzx_rr8(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xB6;\
							alphaptr[n++]=0xC0+(i)+((j)<<3);
#define m_movzx_rr16(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xB7;\
							alphaptr[n++]=0xC0+(i)+((j)<<3);
#define m_movsx_mr8(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xBE;\
							alphaptr[n++]=0x00+(j)+((i)<<3);
#define m_movsx_mr16(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xBF;\
							alphaptr[n++]=0x00+(j)+((i)<<3);
#define m_movzx_mr8(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xB6;\
							alphaptr[n++]=0x00+(j)+((i)<<3);
#define m_movzx_mr16(i,j)	alphaptr[n++]=0x0F;\
							alphaptr[n++]=0xB7;\
							alphaptr[n++]=0x00+(j)+((i)<<3);
/*Shift instructions*/
#define	m_shr_ri(i,e)	alphaptr[n++]=0xC1;\
						alphaptr[n++]=0xE8+(i);\
						alphaptr[n++]=e;

#define m_shl_ri(i,e)	alphaptr[n++]=0xC1;\
						alphaptr[n++]=0xE0+(i);\
						alphaptr[n++]=e;

#define m_sar_ri(i,e)	alphaptr[n++]=0xC1;\
						alphaptr[n++]=0xF8+(i);\
						alphaptr[n++]=e;

#define m_shr_rcl(i)	alphaptr[n++]=0xD3;\
						alphaptr[n++]=0xE8+(i);

#define m_shl_rcl(i)	alphaptr[n++]=0xD3;\
						alphaptr[n++]=0xE0+(i);

#define m_sar_rcl(i)	alphaptr[n++]=0xD3;\
						alphaptr[n++]=0xF8+(i);
/*Conditions*/
#define cond_o	0x0
#define cond_no	0x1
#define cond_b	0x2
#define cond_nb	0x3
#define cond_z	0x4
#define cond_nz	0x5
#define cond_na	0x6
#define cond_a	0x7
#define cond_s	0x8
#define cond_ns	0x9
#define cond_p	0xA
#define cond_np	0xB
#define cond_l	0xC
#define cond_ge	0xD
#define cond_le	0xE
#define cond_g	0xF

#define cond_e	cond_z
#define cond_ne cond_nz
#define m_set_r(i,o)	alphaptr[n++]=0x0F;\
						alphaptr[n++]=0x90+(o);\
						alphaptr[n++]=0xC0+(i);
/*Branch instructions*/
#define m_call(d)		alphaptr[n++]=0x9A;\
						put_imm32(d,n);n+=4;
#define m_jmp_r(i)		alphaptr[n++]=0xFF;\
						alphaptr[n++]=0xE0+(i);
/*Multiplication/Division*/
#define m_udiv(i)		alphaptr[n++]=0xF7;\
						alphaptr[n++]=0xF0+i;
#define m_sdiv(i)		alphaptr[n++]=0xF7;\
						alphaptr[n++]=0xF8+i;
#define m_umul(i)		alphaptr[n++]=0xF7;\
						alphaptr[n++]=0xE0+i;
#define m_smul(i)		alphaptr[n++]=0xF7;\
						alphaptr[n++]=0xE8+i;
/*Push instructions*/
#define m_push_i8(e)	alphaptr[n++]=0x6A;\
						alphaptr[n++]=e;
#define m_push_i(e)		alphaptr[n++]=0x68;\
						put_imm32(e,n);n+=4;
#define m_push_r(i)		alphaptr[n++]=0x50+(i);
#define m_pop_r(i)		alphaptr[n++]=0x58+(i);

ptsize bra_alpha[256];
uint32 bra_mips[256];
long bra_nb;

int load_counter(opsize *dest);
int save_counter(opsize *dest);
void recompile_inst();
void recompile_block(uint32 addr);
void go_header(ptsize address);

#include "macros.h"
