#ifndef GPU_H
#define GPU_H

typedef enum { pal16 = 0, pal256 = 1, hicol = 2} palette_type;

typedef struct {
	int dtd;	/*Dithering*/
	int dfe;	/*Draw to display area permission*/
	int md;		/*Apply mask bit to drawn pixel ON/OFF*/
	int me;		/*No drawing to pixels with set mask ON/OFF*/
	uint32 _md_,_me_;/*same as above, but multiplied by 0xFF*/
	uint32 tp_x,tp_y;      /*Texture page coordinates*/
	uint32 twx,twy,tww,twh; /*Texture window settings*/
	palette_type tp_pal;    /*Texture page color mode*/
	int mask1,mask2;        /*mask settings*/
	int abr;                /*Semi-transparent state*/
	int unsigned dofs_x,dofs_y;
	int unsigned rofs_x,rofs_y;
	int unsigned ofs_x,ofs_y;
	int unsigned clip_x,clip_y,clip_w,clip_h;
	sint16 oxi,oxf,oyi,oyf;
} gpu_state;


//#define GPU_DEBUG(s) printf##s;
#define GPU_DEBUG(s)

uint32 gp0read();
void gp0write(uint32 af);
void gpufunc(uint32 af);
void gpudma();

uint32 pak[16];			/*Packet data*/
gpu_state gs;
#endif
