#include "gpu.h"

typedef struct {
	uint16  u[4],v[4];  /*Texture coordinates*/
	uint16  texx,texy;  /*Texture page VRAM coordinates*/
	uint16  clux,cluy;  /*Color palette VRAM coordinates*/
	palette_type tx_pal;	 /*color mode*/
} texture;

typedef struct {
	sint16	x,y;
	uint16	w,h;
	uint32	c;			/*Blending color*/
	int		t;			/*Transparency*/
	int		m;
	texture	tex;
} sprite;

typedef struct {
	sint16  x[2],y[2];
	uint32  c;
	int		t;
} fs_line;

typedef struct {
	sint16  x[2],y[2];
	uint32  c[2];
	int		t;
} gs_line;

typedef struct {
	sint16	x,y;
	sint16	w,h;
	uint32	c;
	int		t;
} block;

typedef struct {
	sint16  x[3],y[3];
	uint32  c;
	int		t;
} fs_triangle;

typedef struct {
	sint16  x[3],y[3];
	uint32  c[3];
	int		t;
} gs_triangle;

typedef struct {
	sint16	x[4],y[4];
	uint32	c;
	int		t;
} fs_quadrangle;

typedef struct {
	sint16  x[4],y[4];
	uint32  c[4];
	int		t;
} gs_quadrangle;

typedef struct {
	sint16  x[3],y[3];
	uint32  c;
	int		m;
	int		t;
	texture tex;
} fst_triangle;

typedef struct {
	sint16  x[3],y[3];
	uint32  c[3];
	int		m;
	int		t;
	texture tex;
} gst_triangle;

typedef struct {
	sint16	x[4],y[4];
	uint32	c;
	int		m;
	int		t;
	texture tex;
} fst_quadrangle;

typedef struct {
	sint16  x[4],y[4];
	uint32  c[4];
	int		m;
	int		t;
	texture tex;
} gst_quadrangle;
