#define calc_ss(i) \
				ssx =(TRX*1.0)+(R(1,1)*VX(i)+R(1,2)*VY(i)+R(1,3)*VZ(i))/4096.0;\
				ssy =(TRY*1.0)+(R(2,1)*VX(i)+R(2,2)*VY(i)+R(2,3)*VZ(i))/4096.0;\
				ssz =(TRZ*1.0)+(R(3,1)*VX(i)+R(3,2)*VY(i)+R(3,3)*VZ(i))/4096.0

void gte_rtps() {
	double ssx,ssy,ssz,s_x,s_y,p;

	if (debug_gte) printf("# Sope # RTPS\n");
	calc_ss(0);
	IR(1)=Lm_B(ssx,0,1);
	IR(2)=Lm_B(ssy,0,2);
	IR(3)=Lm_B(ssz,0,3);
	SZ(0)=SZ(1);SZ(1)=SZ(2);SZ(2)=SZ(3);SZ(3)=Lm_D(ssz);
	if (SZ(3)==0) {if (debug_gte) printf("GTE division by zero\n");return;}
	s_x=(OFX/65536.0)+IR(1)*(1.0*H/SZ(3));
	s_y=(OFY/65536.0)+IR(2)*(1.0*H/SZ(3));
	p = DQB/4096.0 + DQA*16.0*(1.0*H/SZ(3));
	IR(0)=Lm_H(p);
	SX(0)=SX(1);SX(1)=SX(2);SX(2)=Lm_G(s_x,1);
	SY(0)=SY(1);SY(1)=SY(2);SY(2)=Lm_G(s_y,2);
	MAC(0)=Lm_F(p*4096.0);
	MAC(1)=Lm_A(ssx,1);
	MAC(2)=Lm_A(ssy,2);
	MAC(3)=Lm_A(ssz,3);

}

void gte_rtpt() {

	int unsigned n;
	double ssx,ssy,ssz,s_x,s_y,p;

	/*T-REX: 10%*/
	if (debug_gte) printf("# Sope # RTPT\n");
	SZ(0)=SZ(3);
	for (n=0;n<3;n++) {
		calc_ss(n);
		SZ(n+1)=Lm_D(ssz);
		if (SZ(n+1)==0) {if (debug_gte) printf("GTE division by zero\n");return;}
		s_x=(OFX/65536.0)+ssx*(1.0*H/SZ(n+1));
		s_y=(OFY/65536.0)+ssy*(1.0*H/SZ(n+1));
		SX(n)=Lm_G(s_x,1);
		SY(n)=Lm_G(s_y,2);
	}
	p=DQB/4096.0+DQA*16.0*(1.0*H/SZ(3));
	IR(0)=Lm_H(p);
	IR(1)=Lm_B(ssx,0,1);
	IR(2)=Lm_B(ssy,0,2);
	IR(3)=Lm_B(ssz,0,3);
	MAC(0)=Lm_F(p*4096.0);
	MAC(1)=Lm_A(ssx,1);
	MAC(2)=Lm_A(ssy,2);
	MAC(3)=Lm_A(ssz,3);
}

void gte_mvmva(int unsigned opc) {

	int unsigned sf,mx,v,cv,lm,args;
	int i,j;
	short signed MX[4][4];
	short signed CV[4],V[4];
	double MT[4];

	if (debug_gte) printf("# Sope # MVMVA\n");
	args=(opc>>11)&0x3ff;
	lm=args&3;
	cv=(args>>2)&3;
	v=(args>>4)&3;
	mx=(args>>6)&3;
	sf=(args>>8)&3;

	switch (mx) {
	case 0:	for (i=1;i<4;i++) {for (j=1;j<4;j++) MX[i][j]=R(i,j);}break;
	case 1:	for (i=1;i<4;i++) {for (j=1;j<4;j++) MX[i][j]=L(i,j);}break;
	case 2:	for (i=1;i<4;i++) {MX[i][1]=LR(i);MX[i][2]=LG(i);MX[i][3]=LB(i);}break;
	case 3:printf("mx MVMVA argument invalid!\n");exit(0);
	}

	switch (v) {
	case 0:	V[1]=VX(0);V[2]=VY(0);V[3]=VZ(0);break;
	case 1:	V[1]=VX(1);V[2]=VY(1);V[3]=VZ(1);break;
	case 2:	V[1]=VX(2);V[2]=VY(2);V[3]=VZ(2);break;
	case 3:	for (i=1;i<4;i++) V[i]=IR(i);break;
	}

	switch (cv) {
	case 0:	CV[1]=TRX;CV[2]=TRY;CV[3]=TRZ;break;
	case 1:	CV[1]=RBK;CV[2]=BBK;CV[3]=GBK;break;
	case 2:	CV[1]=RFC;CV[2]=BFC;CV[3]=GFC;break;
	case 3:	for (i=1;i<4;i++) CV[i]=0;break;
	}

	for (i=1;i<4;i++) 
		MT[i]=CV[i]+(MX[i][1]/4096.0)*V[1]+(MX[i][2]/4096.0)*V[2]+(MX[i][3]/4096.0)*V[3];

	switch(sf) {
	case 0:for (i=1;i<4;i++) {MAC(i)=Lm_A(MT[i]*4096.0,i);IR(i)=Lm_B(MT[i]*4096.0,lm,i);}break;
	case 1:for (i=1;i<4;i++) {MAC(i)=Lm_A(MT[i],i);	   IR(i)=Lm_B(MT[i],lm,i);}break;
	case 2:
	case 3:printf("sf MVMVA argument invalid!\n");exit(0);
	}

}

