//#define FANK 4096.0
#define FANK 1.0
//#define FANK (1.0/4096.0)
void gte_nccs() {
	int i;
	double LL,RRLT,GGLT,BBLT,RR0,BB0,GG0;
	double L[4];
	double RLT,GLT,BLT;

	if (debug_gte) printf("# Sope # NCCS\n");
	for (i=1;i<4;i++) {
		LL=L(i,1)*(VX(0)/4096.0)+L(i,2)*(VY(0)/4096.0)+L(i,3)*(VZ(0)/4096.0);
		L[i]=Lm_B(LL,1,i)/4096.0;
	}
	RRLT = (RBK/FANK)+LR(1)*L[1]+LR(2)*L[2]+LR(3)*L[3];
	GGLT = (GBK/FANK)+LG(1)*L[1]+LG(2)*L[2]+LG(3)*L[3];
	BBLT = (BBK/FANK)+LB(1)*L[1]+LB(2)*L[2]+LB(3)*L[3];
	RLT=Lm_B(RRLT,1,1)/4096.0;
	GLT=Lm_B(GGLT,1,2)/4096.0;
	BLT=Lm_B(BBLT,1,3)/4096.0;
	RR0=1.0*CR*RLT;
	GG0=1.0*CG*GLT;
	BB0=1.0*CB*BLT;
	IR(1)=Lm_B(RR0*16.0,1,1);
	IR(2)=Lm_B(GG0*16.0,1,2);
	IR(3)=Lm_B(BB0*16.0,1,3);
	_CD_(0)=_CD_(1);_CD_(1)=_CD_(2);_CD_(2)=CODE;
	_R_(0)=_R_(1);_R_(1)=_R_(2);_R_(2)=Lm_C(RR0,1);
	_G_(0)=_G_(1);_G_(1)=_G_(2);_G_(2)=Lm_C(GG0,2);
	_B_(0)=_B_(1);_B_(1)=_B_(2);_B_(2)=Lm_C(BB0,3);
	MAC(1)=Lm_A(RR0*16.0,1);
	MAC(2)=Lm_A(GG0*16.0,2);
	MAC(3)=Lm_A(BB0*16.0,3);
}

void gte_ncct() {
	int i,j;
	double LL,RRLT,GGLT,BBLT,RR0,BB0,GG0;
	double L[4];
	double RLT,GLT,BLT;

	if (debug_gte) printf("# Sope # NCCT\n");
	for (j=0;j<3;j++) {
		for (i=1;i<4;i++) {
			LL=L(i,1)*(VX(j)/4096.0)+L(i,2)*(VY(j)/4096.0)+L(i,3)*(VZ(j)/4096.0);
			L[i]=Lm_B(LL,1,i)/4096.0;
		}
		RRLT = (RBK/FANK)+LR(1)*L[1]+LR(2)*L[2]+LR(3)*L[3];
		GGLT = (GBK/FANK)+LG(1)*L[1]+LG(2)*L[2]+LG(3)*L[3];
		BBLT = (BBK/FANK)+LB(1)*L[1]+LB(2)*L[2]+LB(3)*L[3];
		RLT=Lm_B(RRLT,1,1)/4096.0;
		GLT=Lm_B(GGLT,1,2)/4096.0;
		BLT=Lm_B(BBLT,1,3)/4096.0;
		RR0=1.0*CR*RLT;
		GG0=1.0*CG*GLT;
		BB0=1.0*CB*BLT;
		_CD_(j)=CODE;
		_R_(j)=Lm_C(RR0,1);
		_G_(j)=Lm_C(GG0,2);
		_B_(j)=Lm_C(BB0,3);
	}

	IR(1)=Lm_B(RR0*16.0,1,1);
	IR(2)=Lm_B(GG0*16.0,1,2);
	IR(3)=Lm_B(BB0*16.0,1,3);
	MAC(1)=Lm_A(RR0*16.0,1);
	MAC(2)=Lm_A(GG0*16.0,2);
	MAC(3)=Lm_A(BB0*16.0,3);

}


void gte_ncdt() {
	int i,j;
	double LL,RRLT,GGLT,BBLT,RR0,BB0,GG0;
	double L[4];
	double RLT,GLT,BLT;

	if (debug_gte) printf("# Sope # NCDT\n");
	/*10% in T-REX*/
	for (j=0;j<3;j++) {
		for (i=1;i<4;i++) {
			LL=L(i,1)*(VX(j)/4096.0)+L(i,2)*(VY(j)/4096.0)+L(i,3)*(VZ(j)/4096.0);
			L[i]=Lm_B(LL,1,i)/4096.0;
		}
		RRLT = (RBK/FANK)+LR(1)*L[1]+LR(2)*L[2]+LR(3)*L[3];
		GGLT = (GBK/FANK)+LG(1)*L[1]+LG(2)*L[2]+LG(3)*L[3];
		BBLT = (BBK/FANK)+LB(1)*L[1]+LB(2)*L[2]+LB(3)*L[3];
		RLT=Lm_B(RRLT,1,1)/4096.0;
		GLT=Lm_B(GGLT,1,2)/4096.0;
		BLT=Lm_B(BBLT,1,3)/4096.0;
		RR0=(CR/1.0)*RLT+(IR(0)/4096.0)*Lm_B(RFC*1.0-(CR/1.0)*RLT,0,1);
		GG0=(CG/1.0)*GLT+(IR(0)/4096.0)*Lm_B(GFC*1.0-(CG/1.0)*GLT,0,2);
		BB0=(CB/1.0)*BLT+(IR(0)/4096.0)*Lm_B(BFC*1.0-(CB/1.0)*BLT,0,3);
		_CD_(j)=CODE;
		_R_(j)=Lm_C(RR0,1);
		_G_(j)=Lm_C(GG0,2);
		_B_(j)=Lm_C(BB0,3);
	}

	IR(1)=Lm_B(RR0*16.0,1,1);
	IR(2)=Lm_B(GG0*16.0,1,2);
	IR(3)=Lm_B(BB0*16.0,1,3);
	MAC(1)=Lm_A(RR0*16.0,1);
	MAC(2)=Lm_A(GG0*16.0,2);
	MAC(3)=Lm_A(BB0*16.0,3);
}

void gte_ncds() {
	int i;
	double LL,RRLT,GGLT,BBLT,RR0,BB0,GG0;
	double L[4];
	double RLT,GLT,BLT;

	if (debug_gte) printf("# Sope # NCDS\n");
	for (i=1;i<4;i++) {
		LL=L(i,1)*(VX(0)/4096.0)+L(i,2)*(VY(0)/4096.0)+L(i,3)*(VZ(0)/4096.0);
		L[i]=Lm_B(LL,1,i)/4096.0; 
	}
	RRLT = (RBK/FANK)+LR(1)*L[1]+LR(2)*L[2]+LR(3)*L[3];
	GGLT = (GBK/FANK)+LG(1)*L[1]+LG(2)*L[2]+LG(3)*L[3];
	BBLT = (BBK/FANK)+LB(1)*L[1]+LB(2)*L[2]+LB(3)*L[3];
	RLT=Lm_B(RRLT,1,1)/4096.0;
	GLT=Lm_B(GGLT,1,2)/4096.0;
	BLT=Lm_B(BBLT,1,3)/4096.0;
	RR0=(CR/1.0)*RLT+(IR(0)/4096.0)*Lm_B(RFC*1.0-(CR/1.0)*RLT,0,1);
	GG0=(CG/1.0)*GLT+(IR(0)/4096.0)*Lm_B(GFC*1.0-(CG/1.0)*GLT,0,2);
	BB0=(CB/1.0)*BLT+(IR(0)/4096.0)*Lm_B(BFC*1.0-(CB/1.0)*BLT,0,3);

	_CD_(0)=_CD_(1);_CD_(1)=_CD_(2);_CD_(2)=CODE;
	_R_(0)=_R_(1);_R_(1)=_R_(2);_R_(2)=Lm_C(RR0,1);
	_G_(0)=_G_(1);_G_(1)=_G_(2);_G_(2)=Lm_C(GG0,2);
	_B_(0)=_B_(1);_B_(1)=_B_(2);_B_(2)=Lm_C(BB0,3);

	IR(1)=Lm_B(RR0*16.0,1,1);
	IR(2)=Lm_B(GG0*16.0,1,2);
	IR(3)=Lm_B(BB0*16.0,1,3);
	MAC(1)=Lm_A(RR0*16.0,1);
	MAC(2)=Lm_A(GG0*16.0,2);
	MAC(3)=Lm_A(BB0*16.0,3);
}

