/* FIXME:
 *
 * --Not endian modifed yet:
 *
 *   L(n,m)
 *   LR(n)
 *   LG(n)
 *   LB(n)
 *
 *		 */

/*"VX0VY0","VZ0","VX1VY1","VZ1","VX2VY2","VZ2","RGB","OTZ",
"IR0","IR1","IR2","IR3","SX0SY0","SX1SY1","SX2SY2","SXPSYP",
"SZ0","SZ1","SZ2","SZ3","R0G0B0","R1G1B1","R2G2B2","RES1",
"MAC0","MAC1","MAC2","MAC3","IRGB","ORGB","LZCS","LZCR"};*/

/*FIXME: Something nicer should be implemented here*/
#ifdef GRAND_ENDIAN
#define BE 1
#else
#define BE 0
#endif

#define CR		BGTE_R1[24]
#define CG		BGTE_R1[25]
#define CB		BGTE_R1[26]
#define CODE	BGTE_R1[27]

#define _R_(n)	BGTE_R1[80+4*n]
#define _G_(n)	BGTE_R1[81+4*n]
#define _B_(n)	BGTE_R1[82+4*n]
#define _CD_(n) BGTE_R1[83+4*n]

#define VX(n) 	SGTE_R1[4*n+BE]
#define VY(n) 	SGTE_R1[4*n+1-BE]
#define VZ(n) 	SGTE_R1[4*n+2+BE]
#define OTZ		IGTE_R1[7]

#define SX(n) 	SGTE_R1[24+2*n+BE]
#define SY(n) 	SGTE_R1[24+2*n+1-BE]

/*#define IR(n) 	IGTE_R1[8+n]*/
#define IR(n)	SGTE_R1[16+2*n+BE]
#define SZ(n)	IGTE_R1[16+n]
/*#define SZ(n) 	ctx.gte1[16+n]*/

#define MAC(n) 	IGTE_R1[24+n]

#define IRGB 	ctx.gte1[28]
#define ORGB	ctx.gte1[29]
#define LZCS	ctx.gte1[30]
#define S_LZCS	((sint32 *)ctx.gte1)[30]
#define LZCR	ctx.gte1[31]

/*"R11R12","R13R21","R22R23","R31R32","R33","TRX","TRY","TRZ",
"L11L12","L13L21","L22L23","L31L32","L33","RBK","GBK","BBK",
"LR1LR2","LR3LG1","LG2LG3","LB1LB2","LB3","RFC","GFC","BFC",
"OFX","OFY","H","DQA","DQB","ZSF3","ZSF4","FLAG"}; */

#ifdef BIG_ENDIAN
#define R(n,m)	SGTE_R2[1+(((3*(n-1)+(m-1))/2)*2)-((3*(n-1)+(m-1))%2)]
#define L(n,m)	SGTE_R2[3*n+m+12]
#define LR(n)	SGTE_R2[31+n]
#define LG(n)	SGTE_R2[34+n]
#define LB(n)	SGTE_R2[37+n]
#else
#define R(n,m) 	SGTE_R2[3*n+m-4]
#define L(n,m) 	SGTE_R2[3*n+m+12]
#define LR(n) 	SGTE_R2[31+n]
#define LG(n) 	SGTE_R2[34+n]
#define LB(n) 	SGTE_R2[37+n]
#endif

#define TRX 	IGTE_R2[5]
#define TRY 	IGTE_R2[6]
#define TRZ 	IGTE_R2[7]

#define RBK		IGTE_R2[13]
#define GBK		IGTE_R2[14]
#define BBK		IGTE_R2[15]

#define RFC		IGTE_R2[21]
#define GFC		IGTE_R2[22]
#define BFC		IGTE_R2[23]

#define OFX 	IGTE_R2[24]
#define OFY 	IGTE_R2[25]
#define H	 	IGTE_R2[26]
#define DQA 	IGTE_R2[27]
#define DQB 	IGTE_R2[28]
#define ZSF3 	IGTE_R2[29]
#define ZSF4 	IGTE_R2[30]
#define FLAG 	ctx.gte2[31]


#define setbitflag(f) FLAG|=(1<<(f))
#define clearbitflag(f) FLAG&=(1<<(f))^(0xFFFFFFFF)

static int signed Lm_A(double ss,int p) {
int signed cc;
clearbitflag(31-p);
clearbitflag(28-p);
if (ss>2147483647.0)  {setbitflag(31-p);return(2147483647);}
if (ss<-2147483648.0) {setbitflag(28-p);return(-2147483648);}
cc=rint(ss);
return(cc);
}

static short signed Lm_B(double ss,int lm,int p) {
short signed cc;

if (ss>32767) {setbitflag(25-p);return(32767);}
switch(lm) {
case 0:	if (ss<-32768) {setbitflag(25-p);return(-32768);}break;
case 1: if (ss<0)	  {setbitflag(25-p);return(0);}break;
case 2:
case 3:printf("lm MVMVA argument invalid!\n");exit(0);
}		
cc=rint(ss);
clearbitflag(25-p);
return(cc);
}

static char unsigned Lm_C(double ss,int p) {
char unsigned cc;
if (ss<0)   {setbitflag(22-p);return(0);}
if (ss>255) {setbitflag(22-p);return(255);}
cc=rint(ss);
clearbitflag(22-p);
return(cc);
}

static short unsigned Lm_D(double ss) {
short unsigned cc;
if (ss<0)	 {setbitflag(18);return(0);}
if (ss>65535) {setbitflag(18);return(65535);}
cc=rint(ss);
clearbitflag(18);
return(cc);
}

static sint32 Lm_F(double ss) {
sint32 cc;

clearbitflag(16);
clearbitflag(15);
if (ss>2147483647.0)  {setbitflag(16);return(2147483647);}
if (ss<-2147483648.0) {setbitflag(15);return(-2147483648);}
cc=rint(ss);
return(cc);
} 

static short signed Lm_G(sint32 ss,int p) {
short signed cc;
if (ss<-1024) {setbitflag(15-p);return(-1024);}
if (ss>1023)  {setbitflag(15-p);return(1023);}
cc=ss;
clearbitflag(15-p);
return(cc);
}

static short unsigned Lm_H(double ss) {
short unsigned cc;
if (ss<0)	{setbitflag(12);return(0);}
if (ss>4095) {setbitflag(12);return(4095);}
cc=rint(ss);
clearbitflag(12);
return(cc);
}


