#include <gtk/gtk.h>
#include <string.h>

#include "gtk_callbacks.h"
#include "gtk_interface.h"
#include "gtk_support.h"

void on_exit_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	ciao("");
}


void on_run_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	if (rnd == NULL) {
		gui->print("First select a valid renderer!");
		return;
	}
	bootrom();
	update_debug_window();
}

void on_reset_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	resetpsx();
	update_debug_window();
}


void on_ok_button1_clicked(GtkButton * button, gpointer user_data)
{
	gchar *filename;

	gtk_widget_hide(file_selection_window);
	filename =
		gtk_file_selection_get_filename(GTK_FILE_SELECTION
										(file_selection_window));
	loadanyfile(filename);
}


void on_cancel_button1_clicked(GtkButton * button, gpointer user_data)
{
	gtk_widget_hide(file_selection_window);
}


void loadfile_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	if (file_selection_window == NULL)
		file_selection_window = create_fileselection();
	gtk_widget_show(file_selection_window);
	gdk_window_raise(file_selection_window->window);
}

int debug_on = 0;
int prefs_on = 0;

void
on_toggle_prefs_toggled(GtkCheckMenuItem * checkmenuitem,
						gpointer user_data)
{
	prefs_on = 1 - prefs_on;
	prefs_check = checkmenuitem;
	if (prefs_window == NULL) {
		prefs_window = create_prefs_window();
		gtk_widget_hide(prefs_window);
	}
	if (prefs_on)
		gtk_widget_show(prefs_window);
	else
		gtk_widget_hide(prefs_window);
}

void
on_toggle_debug_toggled(GtkCheckMenuItem * checkmenuitem,
						gpointer user_data)
{
	debug_on = 1 - debug_on;
	debug_check = checkmenuitem;
	if (debug_window == NULL) {
		debug_window = create_debug_window();
		gtk_widget_hide(debug_window);
	}
	if (debug_on)
		gtk_widget_show(debug_window);
	else
		gtk_widget_hide(debug_window);
}


void on_prefs_window_destroy(GtkObject * object, gpointer user_data)
{
	prefs_window = NULL;
	gtk_check_menu_item_set_active(prefs_check, FALSE);
}


void on_debug_window_destroy(GtkObject * object, gpointer user_data)
{
	debug_window = NULL;
	gtk_check_menu_item_set_active(debug_check, FALSE);
}

GtkWidget *clist;
char *valid_result = "OK";
char *invalid_result = "Error";

void gtk_fonc(char *filename, char *about)
{
	gchar *elements[3];

	elements[0] = filename;
	if (strstr(about, ":") != NULL) {
		elements[1] = invalid_result;
		elements[2] = strstr(about, ":") + 2;
	} else {
		elements[1] = valid_result;
		elements[2] = about;
	}
	gtk_clist_prepend(GTK_CLIST(clist), elements);
}

void
on_renderer_plugin_list_realize(GtkWidget * widget, gpointer user_data)
{
	clist = widget;
	list_renderer_plugins(gtk_fonc);
}


void
on_renderer_plugin_list_select_row(GtkCList * clist, gint row, gint column,
								   GdkEventButton * event,
								   gpointer user_data)
{
	gchar *fn;
	gchar result[64];

	gtk_clist_get_text(GTK_CLIST(clist), row, 0, &fn);
	if (load_renderer_plugin(fn, result))
		rnd->start(&gs, glbuf);
}

void on_sound_plugin_list_realize(GtkWidget * widget, gpointer user_data)
{
	clist = widget;
	list_sound_plugins(gtk_fonc);
}


void
on_sound_plugin_list_select_row(GtkCList * clist, gint row, gint column,
								GdkEventButton * event, gpointer user_data)
{
	gchar *fn;
	gchar result[64];

	gtk_clist_get_text(GTK_CLIST(clist), row, 0, &fn);
	load_sound_plugin(fn, result);
	init_sound();
}

/**************************************************************/
GtkWidget *plugin_conf_window;
#define state(i) (((i)==0)?FALSE:TRUE)
void on_configure_clicked(GtkWidget * widget, gpointer user_data)
{
	Config_Param *params;
	int i, n;
	long p;
	GtkWidget *vbox;
	GtkWidget *table;
	GtkWidget *param_widget;

	p = (long) user_data;
	switch (p) {
	case 0:
		if (rnd == NULL)
			return;
		n = rnd->config_list->nb;
		params = rnd->config_list->params;
		break;
	case 1:
		if (snd == NULL)
			return;
		n = snd->config_list->nb;
		params = snd->config_list->params;
		break;
	default:
		return;
	}

	plugin_conf_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(plugin_conf_window),
						 "Configure Plugin");
	gtk_widget_set_usize(GTK_WIDGET(plugin_conf_window), 200, 0);
	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(plugin_conf_window), vbox);
	gtk_widget_show(vbox);

	table = gtk_table_new(n + 1, 1, TRUE);
	for (i = 0; i < n; i++) {
		switch (params[i].type) {
		case boolean:
			param_widget = gtk_check_button_new_with_label(params[i].name);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(param_widget),
										 state(params[i].value));
			break;
		case integer:
			break;
		}
		gtk_table_attach_defaults(GTK_TABLE(table), param_widget,
								  0, 1, i, i + 1);
		gtk_widget_show(param_widget);
	}
	param_widget = gtk_button_new_with_label("Apply Changes");
	gtk_table_attach_defaults(GTK_TABLE(table), param_widget, 0, 1, n,
							  n + 1);
	gtk_widget_show(param_widget);
	gtk_box_pack_start(GTK_BOX(vbox), table, FALSE, FALSE, 0);
	gtk_widget_show(table);
	gtk_widget_show(plugin_conf_window);


}
