#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "gtk_callbacks.h"
#include "gtk_interface.h"
#include "gtk_support.h"

GtkWidget *create_window1(void)
{
	GtkWidget *window1;
	GtkWidget *vbox;
	GtkWidget *menubar;
	GtkWidget *File;
	GtkWidget *File_menu;
	GtkAccelGroup *File_menu_accels;
	GtkWidget *loadfile;
	GtkWidget *exit;
	GtkWidget *Action;
	GtkWidget *Action_menu;
	GtkAccelGroup *Action_menu_accels;
	GtkWidget *run;
	GtkWidget *reset;
	GtkWidget *Tools;
	GtkWidget *Tools_menu;
	GtkAccelGroup *Tools_menu_accels;
	GtkWidget *toggle_prefs;
	GtkWidget *toggle_debug;
	GtkAccelGroup *accel_group;

	accel_group = gtk_accel_group_new();

	window1 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data(GTK_OBJECT(window1), "window1", window1);
	gtk_window_set_title(GTK_WINDOW(window1), "window1");

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox);
	gtk_container_add(GTK_CONTAINER(window1), vbox);

	menubar = gtk_menu_bar_new();
	gtk_widget_show(menubar);
	gtk_box_pack_start(GTK_BOX(vbox), menubar, FALSE, FALSE, 0);

	File = gtk_menu_item_new_with_label("File");
	gtk_widget_show(File);
	gtk_container_add(GTK_CONTAINER(menubar), File);

	File_menu = gtk_menu_new();
	gtk_widget_ref(File_menu);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(File), File_menu);
	File_menu_accels =
		gtk_menu_ensure_uline_accel_group(GTK_MENU(File_menu));

	loadfile = gtk_menu_item_new_with_label("Load File");
	gtk_widget_show(loadfile);
	gtk_container_add(GTK_CONTAINER(File_menu), loadfile);
	gtk_widget_add_accelerator(loadfile, "activate", accel_group,
							   GDK_L, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	exit = gtk_menu_item_new_with_label("Exit");
	gtk_widget_show(exit);
	gtk_container_add(GTK_CONTAINER(File_menu), exit);
	gtk_widget_add_accelerator(exit, "activate", accel_group,
							   GDK_X, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	Action = gtk_menu_item_new_with_label("Action");
	gtk_widget_show(Action);
	gtk_container_add(GTK_CONTAINER(menubar), Action);

	Action_menu = gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(Action), Action_menu);
	Action_menu_accels =
		gtk_menu_ensure_uline_accel_group(GTK_MENU(Action_menu));

	run = gtk_menu_item_new_with_label("Run");
	gtk_widget_show(run);
	gtk_container_add(GTK_CONTAINER(Action_menu), run);
	gtk_widget_add_accelerator(run, "activate", accel_group,
							   GDK_G, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
	reset = gtk_menu_item_new_with_label("Reset");
	gtk_widget_show(reset);
	gtk_container_add(GTK_CONTAINER(Action_menu), reset);
	gtk_widget_add_accelerator(reset, "activate", accel_group,
							   GDK_R, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	Tools = gtk_menu_item_new_with_label("Tools");
	gtk_widget_show(Tools);
	gtk_container_add(GTK_CONTAINER(menubar), Tools);

	Tools_menu = gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(Tools), Tools_menu);
	Tools_menu_accels =
		gtk_menu_ensure_uline_accel_group(GTK_MENU(Tools_menu));

	toggle_prefs = gtk_menu_item_new();
	gtk_widget_show(toggle_prefs);
	gtk_container_add(GTK_CONTAINER(Tools_menu), toggle_prefs);

	toggle_prefs = gtk_check_menu_item_new_with_label("Preferences");
	gtk_widget_show(toggle_prefs);
	gtk_container_add(GTK_CONTAINER(Tools_menu), toggle_prefs);

	toggle_debug = gtk_check_menu_item_new_with_label("Debugger");
	gtk_widget_show(toggle_debug);
	gtk_container_add(GTK_CONTAINER(Tools_menu), toggle_debug);

	our_output = gtk_label_new("Welcome to Sope!");
	gtk_widget_show(our_output);
	gtk_box_pack_start(GTK_BOX(vbox), our_output, FALSE, FALSE, 0);

	psx_output = gtk_text_new(NULL, NULL);
	gtk_widget_show(psx_output);
	gtk_box_pack_start(GTK_BOX(vbox), psx_output, TRUE, TRUE, 0);
	gtk_widget_set_usize(psx_output, 400, 300);

	gtk_signal_connect(GTK_OBJECT(loadfile), "activate",
					   GTK_SIGNAL_FUNC(loadfile_activate), NULL);
	gtk_signal_connect(GTK_OBJECT(exit), "activate",
					   GTK_SIGNAL_FUNC(on_exit_activate), NULL);
	gtk_signal_connect(GTK_OBJECT(run), "activate",
					   GTK_SIGNAL_FUNC(on_run_activate), NULL);
	gtk_signal_connect(GTK_OBJECT(reset), "activate",
					   GTK_SIGNAL_FUNC(on_reset_activate), NULL);
	gtk_signal_connect(GTK_OBJECT(toggle_debug), "toggled",
					   GTK_SIGNAL_FUNC(on_toggle_debug_toggled), NULL);
	gtk_signal_connect(GTK_OBJECT(toggle_prefs), "toggled",
					   GTK_SIGNAL_FUNC(on_toggle_prefs_toggled), NULL);

	gtk_window_add_accel_group(GTK_WINDOW(window1), accel_group);

	return window1;
}

GtkWidget *create_fileselection(void)
{
	GtkWidget *fileselection;
	GtkWidget *ok_button1;
	GtkWidget *cancel_button1;

	fileselection = gtk_file_selection_new("Select EXE or PLL File");
	gtk_object_set_data(GTK_OBJECT(fileselection), "fileselection",
						fileselection);
	gtk_container_set_border_width(GTK_CONTAINER(fileselection), 10);
	gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION
										   (fileselection));

	ok_button1 = GTK_FILE_SELECTION(fileselection)->ok_button;
	gtk_object_set_data(GTK_OBJECT(fileselection), "ok_button1",
						ok_button1);
	gtk_widget_show(ok_button1);
	GTK_WIDGET_SET_FLAGS(ok_button1, GTK_CAN_DEFAULT);

	cancel_button1 = GTK_FILE_SELECTION(fileselection)->cancel_button;
	gtk_object_set_data(GTK_OBJECT(fileselection), "cancel_button1",
						cancel_button1);
	gtk_widget_show(cancel_button1);
	GTK_WIDGET_SET_FLAGS(cancel_button1, GTK_CAN_DEFAULT);

	gtk_signal_connect(GTK_OBJECT(ok_button1), "clicked",
					   GTK_SIGNAL_FUNC(on_ok_button1_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(cancel_button1), "clicked",
					   GTK_SIGNAL_FUNC(on_cancel_button1_clicked), NULL);

	return fileselection;
}

/***************************************************************************/
/*                     Preferences Window                                  */
/***************************************************************************/
gchar *list_titles[3] = { "Filename", "Status", "Message" };

GtkWidget *add_plugin_list_to_notebook(GtkWidget * notebook, char *title,
									   int i)
{
	GtkWidget *notebook_page;
	GtkWidget *plugin_list;
	GtkWidget *scrolled_window;
	GtkWidget *label;
	GtkWidget *button;

	notebook_page = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(notebook_page);
	gtk_container_add(GTK_CONTAINER(notebook), notebook_page);

	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_set_usize(scrolled_window, 250, 150);
	gtk_box_pack_start(GTK_BOX(notebook_page), scrolled_window, FALSE,
					   FALSE, 0);
	gtk_widget_show(scrolled_window);

	plugin_list = gtk_clist_new_with_titles(3, list_titles);
	gtk_clist_set_selection_mode(GTK_CLIST(plugin_list),
								 GTK_SELECTION_BROWSE);
	gtk_clist_set_column_width(GTK_CLIST(plugin_list), 0, 100);
	gtk_clist_set_column_width(GTK_CLIST(plugin_list), 1, 50);
	gtk_clist_set_column_width(GTK_CLIST(plugin_list), 2, 280);
	gtk_clist_set_shadow_type(GTK_CLIST(plugin_list), GTK_SHADOW_IN);
	gtk_clist_column_titles_passive(GTK_CLIST(plugin_list));
	gtk_container_add(GTK_CONTAINER(scrolled_window), plugin_list);
	gtk_widget_show(plugin_list);
	gtk_widget_set_usize(plugin_list, -2, 20);
	gtk_container_set_border_width(GTK_CONTAINER(plugin_list), 8);
	label = gtk_label_new(title);
	gtk_widget_show(label);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(notebook),
							   gtk_notebook_get_nth_page(GTK_NOTEBOOK
														 (notebook), i),
							   label);
	button = gtk_button_new_with_label("Configure");
	gtk_box_pack_start(GTK_BOX(notebook_page), button, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(on_configure_clicked),
					   (gpointer) i);
	gtk_widget_show(button);
	return plugin_list;
}

GtkWidget *create_prefs_window(void)
{
	GtkWidget *prefs_window;
	GtkWidget *vbox;
	GtkWidget *notebook;
	GtkWidget *renderer_plugin_list;
	GtkWidget *sound_plugin_list;

	prefs_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_object_set_data(GTK_OBJECT(prefs_window), "prefs_window",
						prefs_window);
	gtk_widget_set_usize(prefs_window, 0, 230);
	gtk_window_set_title(GTK_WINDOW(prefs_window), "Preferences");

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox);
	gtk_container_add(GTK_CONTAINER(prefs_window), vbox);

	notebook = gtk_notebook_new();
	gtk_widget_show(notebook);
	gtk_box_pack_start(GTK_BOX(vbox), notebook, TRUE, TRUE, 0);
	gtk_widget_set_usize(notebook, 500, 0);

	renderer_plugin_list =
		add_plugin_list_to_notebook(notebook, "Rendering", 0);
	sound_plugin_list = add_plugin_list_to_notebook(notebook, "Sound", 1);


	gtk_signal_connect(GTK_OBJECT(prefs_window), "destroy",
					   GTK_SIGNAL_FUNC(on_prefs_window_destroy), NULL);
	gtk_signal_connect(GTK_OBJECT(renderer_plugin_list), "realize",
					   GTK_SIGNAL_FUNC(on_renderer_plugin_list_realize),
					   NULL);
	gtk_signal_connect(GTK_OBJECT(renderer_plugin_list), "select_row",
					   GTK_SIGNAL_FUNC(on_renderer_plugin_list_select_row),
					   NULL);
	gtk_signal_connect(GTK_OBJECT(sound_plugin_list), "realize",
					   GTK_SIGNAL_FUNC(on_sound_plugin_list_realize),
					   NULL);
	gtk_signal_connect(GTK_OBJECT(sound_plugin_list), "select_row",
					   GTK_SIGNAL_FUNC(on_sound_plugin_list_select_row),
					   NULL);


	return prefs_window;
}

/*************************************************************************/
/*              Debugger window                                          */
/*************************************************************************/

char *reg_names[4][32] = {
	{
	 "r0", "at", "v0", "v1", "a0", "a1", "a2", "a3",
	 "t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7",
	 "s0", "s1", "s2", "s3", "s4", "s5", "s6", "s7",
	 "t8", "t9", "k0", "k1", "gp", "sp", "s8", "ra"},
	{
	 "Index", "Random", "EntryLO", "***", "Context", "***", "***", "***",
	 "BadVA", "***", "EntryHI", "***", "Status", "Cause", "EPC", "PRId",
	 "***", "***", "***", "***", "***", "***", "***", "***",
	 "***", "***", "***", "***", "***", "***", "***", "***"},
	{"VXY0", "VZ0", "VXY1", "VZ1", "VXY2", "VZ2", "RGB", "OTZ",
	 "IR0", "IR1", "IR2", "IR3", "SXY0", "SXY1", "SXY2", "SXYP",
	 "SZ0", "SZ1", "SZ2", "SZ3", "RGB0", "RGB1", "RGB2", "RES1",
	 "MAC0", "MAC1", "MAC2", "MAC3", "IRGB", "ORGB", "LZCS", "LZCR"},
	{"R11R12", "R13R21", "R22R23", "R31R32", "R33", "TRX", "TRY", "TRZ",
	 "L11L12", "L13L21", "L22L23", "L31L32", "L33", "RBK", "GBK", "BBK",
	 "LR1LR2", "LR3LG1", "LG2LG3", "LB1LB2", "LB3", "RFC", "GFC", "BFC",
	 "OFX", "OFY", "H", "DQA", "DQB", "ZSF3", "ZSF4", "FLAG"}
};

char *labels[4] = { "CPU", "CP0", "GTE 1/2", "GTE 2/2" };
char *m_regnames[3] = { "pc0", "LO", "HI" };

GtkWidget *add_notebook_page(GtkWidget * notebook, char *title, int i)
{
	GtkWidget *notebook_page;
	GtkWidget *label;

	notebook_page = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(notebook_page);
	gtk_container_add(GTK_CONTAINER(notebook), notebook_page);
	label = gtk_label_new(title);
	gtk_widget_ref(label);
	gtk_widget_show(label);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(notebook),
							   gtk_notebook_get_nth_page(GTK_NOTEBOOK
														 (notebook),
														 i), label);
	return notebook_page;
}

GtkWidget *entry[4][32];
GtkWidget *m_entry[3];

void update_debug_window(void)
{
	char regv[16];
	int i;
	for (i = 0; i < 32; i++) {
		sprintf(regv, "%8.8x", ctx.gpr[i]);
		gtk_entry_set_text(GTK_ENTRY(entry[0][i]), regv);
		sprintf(regv, "%8.8x", ctx.cp0[i]);
		gtk_entry_set_text(GTK_ENTRY(entry[1][i]), regv);
		sprintf(regv, "%8.8x", ctx.gte1[i]);
		gtk_entry_set_text(GTK_ENTRY(entry[2][i]), regv);
		sprintf(regv, "%8.8x", ctx.gte2[i]);
		gtk_entry_set_text(GTK_ENTRY(entry[3][i]), regv);
	}
	sprintf(regv, "%8.8x", ctx.pc0);
	gtk_entry_set_text(GTK_ENTRY(m_entry[0]), regv);
	sprintf(regv, "%8.8x", ctx.LO);
	gtk_entry_set_text(GTK_ENTRY(m_entry[1]), regv);
	sprintf(regv, "%8.8x", ctx.HI);
	gtk_entry_set_text(GTK_ENTRY(m_entry[2]), regv);
}

GtkWidget *create_debug_window(void)
{
	int i, j;
	GtkWidget *debug_window;
	GtkWidget *vbox;
	GtkWidget *notebook;
	GtkWidget *notebook_page;
	GtkWidget *table;

	debug_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(GTK_WIDGET(debug_window), 512, 240);
	gtk_object_set_data(GTK_OBJECT(debug_window), "debug_window",
						debug_window);
	gtk_window_set_title(GTK_WINDOW(debug_window), "Debugger");

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox);
	gtk_widget_show(vbox);
	gtk_container_add(GTK_CONTAINER(debug_window), vbox);

	table = gtk_table_new(1, 8, TRUE);
	for (i = 0; i < 3; i++) {
		GtkWidget *label;

		label = gtk_label_new(m_regnames[i]);
		gtk_table_attach_defaults(GTK_TABLE(table), label, 2 * i,
								  2 * i + 1, 0, 1);
		gtk_widget_show(label);
		m_entry[i] = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(m_entry[i]), "00000000");
		gtk_entry_set_editable(GTK_ENTRY(m_entry[i]), FALSE);
		gtk_table_attach_defaults(GTK_TABLE(table), m_entry[i], 2 * i + 1,
								  2 * i + 2, 0, 1);
		gtk_widget_show(m_entry[i]);
	}
	gtk_box_pack_start(GTK_BOX(vbox), table, FALSE, TRUE, 0);
	gtk_widget_show(table);

	notebook = gtk_notebook_new();
	gtk_widget_ref(notebook);
	gtk_widget_show(notebook);
	gtk_box_pack_start(GTK_BOX(vbox), notebook, TRUE, TRUE, 0);

	for (i = 0; i < 4; i++) {
		notebook_page = add_notebook_page(notebook, labels[i], i);
		table = gtk_table_new(8, 8, TRUE);
		gtk_box_pack_start(GTK_BOX(notebook_page), table, TRUE, TRUE, 0);
		for (j = 0; j < 32; j++) {
			GtkWidget *label;

			label = gtk_label_new(reg_names[i][j]);
			gtk_table_attach_defaults(GTK_TABLE(table), label, (j / 8) * 2,
									  (j / 8) * 2 + 1, j % 8, j % 8 + 1);
			gtk_widget_show(label);
			entry[i][j] = gtk_entry_new();
			gtk_entry_set_text(GTK_ENTRY(entry[i][j]), "00000000");
			gtk_entry_set_editable(GTK_ENTRY(entry[i][j]), FALSE);
			gtk_table_attach_defaults(GTK_TABLE(table), entry[i][j],
									  (j / 8) * 2 + 1, (j / 8) * 2 + 2,
									  j % 8, j % 8 + 1);
			gtk_widget_show(entry[i][j]);
		}
		gtk_widget_show(table);
	}
	notebook_page = add_notebook_page(notebook, "Disassembly", 4);
	gtk_signal_connect(GTK_OBJECT(debug_window), "destroy",
					   GTK_SIGNAL_FUNC(on_debug_window_destroy), NULL);

	return debug_window;
}
