#include "gui_console.h"
#include "sope.h"
#include "renderer.h"
#include "fileio.h"
#include "gpu.h"

UserInterface console_ui = {
	start_ui,
	print,
	PSX_printchar,
	PSX_printstring,
	refresh
};	
	
static void refresh(){
}

static void start_ui(int argc,char *argv[]){
	int i;

	bootrom();
	//move this

	load_renderer_plugin(RENDERER,distring);
	load_sound_plugin(SOUND,distring);
	rnd->start(&gs,glbuf);
	init_sound();
	if (boot_cdrom) cd_boot();
	else
	for (i=1;i<argc;i++) {
		loadanyfile(argv[i]);
	}
	if (enable_dynarec) {
		for (;;) dyn_handle_flow();
	} else {
		for (;;) handle_flow();
	}
}

static void print(char unsigned *s){
	printf("# Sope # %s\n",s);
}

static void PSX_printchar(char unsigned c){
//	printf("\033[01;34m");  /*Enable blue coloring*/
	printf("%c",c);
//	printf("\033[0m");      /*go back to normal color*/
}

static void PSX_printstring(char unsigned *s){
//        printf("\033[01;32m");  /*Enable green coloring*/
	puts(s);
//        printf("\033[0m");      /*go back to normal color*/
}

