#include "gui_gtk.h"

#include "gtk_interface.h"
#include "gtk_support.h"

#include "gpu.h"


UserInterface gtk_ui = {
	gtk_start_ui,
	gtk_print,
	gtk_PSX_printchar,
	gtk_PSX_printstring,
	gtk_refresh
};

GtkWidget *window1;

static void gtk_start_ui(int argc, char *argv[])
{

	gtk_set_locale();
	gtk_init(&argc, &argv);

	window1 = create_window1();
	gtk_widget_show(window1);
	debug_window = create_debug_window();
	prefs_window = create_prefs_window();
	gtk_widget_show(prefs_window);
	gtk_widget_hide(prefs_window);
	bootrom();
	gtk_main();
}

static void gtk_refresh()
{
	gtk_widget_draw(GTK_WIDGET(psx_output), NULL);
}

static void gtk_print(char unsigned *s)
{
	gtk_label_set_text(GTK_LABEL(our_output), s);
}

static void gtk_PSX_printchar(char unsigned c)
{
	gtk_text_insert(GTK_TEXT(psx_output), NULL, &psx_output->style->black,
					NULL, &c, 1);
	gtk_widget_draw(GTK_WIDGET(psx_output), NULL);
}

static void gtk_PSX_printstring(char unsigned *s)
{
	gtk_text_insert(GTK_TEXT(psx_output), NULL, &psx_output->style->black,
					NULL, s, -1);
	gtk_widget_draw(GTK_WIDGET(psx_output), NULL);
}
