void hwrite_byte(uint8 af,uint16 hrn);
void hwrite_word(uint16 af,uint16 hrn);
void hwrite(uint32 af,uint16 hrn);

uint8 hread_byte(uint16 hrn);
uint16 hread_word(uint16 hrn);
uint32 hread(uint16 hrn);

void hwreg(uint32 what,uint16 hf,long i);
uint32 hrreg(uint16 hf,long i);

/* Hardware registers definitions*/

#define	spu_delay	0x1014
#define	dv5_delay	0x1018
#define	com_delay	0x1020

#define sio1_data	0x1040
#define sio1_stat	0x1044
#define sio1_mode	0x1048
#define sio1_ctrl	0x104a
#define sio1_baud	0x104e

#define	ram_size	0x1060	
#define	i_reg		0x1070
#define i_mask		0x1074

/*DMA channels*/
#define	mdecin_madr 	0x1080
#define	mdecin_bcr  	0x1084
#define	mdecin_chcr 	0x1088

#define	mdecout_madr 	0x1090
#define	mdecout_bcr  	0x1094
#define	mdecout_chcr 	0x1098

#define	gpu_madr 	0x10a0
#define	gpu_bcr  	0x10a4
#define	gpu_chcr 	0x10a8

#define	cd_madr 	0x10b0
#define	cd_bcr  	0x10b4
#define	cd_chcr 	0x10b8

#define	spu_madr 	0x10c0
#define	spu_bcr  	0x10c4
#define	spu_chcr 	0x10c8

#define	pio_madr 	0x10d0
#define	pio_bcr  	0x10d4
#define	pio_chcr 	0x10d8

#define	otc_madr 	0x10e0
#define	otc_bcr  	0x10e4
#define	otc_chcr 	0x10e8

#define d_pcr		0x10f0
#define d_icr		0x10f4
/*root counters hw registers*/
#define t0_count	0x1100
#define t0_mode 	0x1104
#define t0_target	0x1108
#define t1_count	0x1110
#define t1_mode 	0x1114
#define t1_target	0x1118
#define t2_count	0x1120
#define t2_mode 	0x1124
#define t2_target	0x1128
/*CD-ROM control*/

#define	cd_reg0	0x1800
#define cd_reg1	0x1801
#define	cd_reg2	0x1802
#define	cd_reg3	0x1803
/*GPU 	control*/
#define	gp0		0x1810
#define gp1		0x1814
/*MDEC 	control*/
#define	mdec_ctrl		0x1820
#define	mdec_stat		0x1824

/*Sound*/
#define voice_base		0x1c00
#define spu_freq		0x1c04

#define spu_vol_left	0x1d80
#define spu_vol_right	0x1d82

#define reverb_depth_l	0x1d84
#define reverb_depth_r	0x1d86

#define spu_keyON_1		0x1d88
#define spu_keyON_2		0x1d8a
#define spu_keyOFF_1	0x1d8c
#define spu_keyOFF_2	0x1d8e
#define spu_sb_addr		0x1da6
#define spu_data		0x1da8
#define sp0				0x1daa
#define sp1				0x1dac
#define sp2				0x1dae

#define cd_mvol_l	0x1db0
#define cd_mvol_r	0x1db2
