#include <string.h>
#include "sope.h"
#include "gui.h"
#include "renderer.h"
#include "sound.h"

void cd_reset();
void loadconf();

void resetpsx() {
	memset(RAOM,0,0x200000);
	memset(ctx.gpr,0,0x80);
	memset(ctx.cp0,0,0x80);
	memset(ctx.gte1,0,0x80);
	memset(ctx.gte2,0,0x80);
	ctx.pc0=0xbfc00000;
	screen_mode=0xff;
	ctx.pbuf=0x200000;
	HRM32(0x1814)=0x74000000;
	cd_reset();
}		

void initall() {
	FILE *f;

	rnd=NULL;
	snd=NULL;
	halt_address=0xfffffffe;
	enable_vsync=0;
	enable_dynarec=1;
	disable_sound=1;
	cd_int=0;
	boot_cdrom=0;
	debug_mask=0;
	dass=0;
	fast_graph=0;
	ctx.nstp=0;
	ncyc=30000;
	resetpsx();
	norender=0;
	notextures=0;
	loadconf();

	f=fopen("bios","r");
	if (f==NULL) {printf(" file \"bios\" not found!\n");ciao("Sigh...");}
	fread(RAOM+0x200000,1,0x80000,f);
	fclose(f);
}

void make_debug_flags() {
	debug_hre=debug_mask&1;
	debug_hwr=(debug_mask>>1)&1;
	debug_sound=(debug_mask>>2)&1;
	debug_dma=(debug_mask>>3)&1;
	debug_gpu=(debug_mask>>4)&1;
	debug_poly=(debug_mask>>5)&1;
	debug_gte=(debug_mask>>6)&1;
	debug_cd=(debug_mask>>7)&1;
	debug_syscall=(debug_mask>>8)&1;
}

void loadconf() {
	FILE *f;
	char data[2048];
	char *ptr,*ptr1;

	strcpy(RENDERER,"libsoft.so");
	strcpy(SOUND,"liboss.so");

	f=fopen ("sope.conf","r");
	if (f==NULL) return;

	fread(data,1,2048,f);

	ptr = strstr (data,"renderer");
	if (ptr == NULL) return;
	while (*ptr!='=') ptr++; ptr++;
	while (*ptr==' ') ptr++;
	ptr1 = ptr;
	while ((*ptr!=' ') & (*ptr!='\n')) ptr++;
	strcpy (RENDERER,"lib");
	strncat (RENDERER,ptr1,ptr-ptr1);
	strcat (RENDERER,".so");
	
	ptr = strstr (data,"sound");
	if (ptr == NULL) return;
	while (*ptr!='=') ptr++; ptr++;
	while (*ptr==' ') ptr++;
	ptr1 = ptr;
	while ((*ptr!=' ') & (*ptr!='\n')) ptr++;
	strcpy (SOUND,"lib");
	strncat (SOUND,ptr1,ptr-ptr1);
	strcat (SOUND,".so");

	fclose(f);
}