#include "sope.h"
#include "hwr.h"
#include "pad.h"

sint8  rm_8s(uint32 mempos) {
      int unsigned coco;
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) return(SRAOM[mempos&0x1fffff]);
      if (coco==0xbf) return(SRAOM[0x200000+(mempos&0x07ffff)]);
      coco=(mempos >> 16);
      if (coco==0x1f00) return(SPAR[mempos&0xffff]);
      if (coco==0x1f80) return(hread_byte(mempos & 0xffff));

      printf("%8.8x: There is no memory at %8.8x ! (s_byte)\n",ctx.pc0,mempos);
      return(0);
}

uint8 rm_8u(uint32 mempos) {
      int unsigned coco;
      if ((mempos&0x1ffffc)==ctx.pbuf) get_pad_buf();
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) return(RAOM[mempos&0x1fffff]);
      if (coco==0xbf) return(RAOM[0x200000+(mempos&0x07ffff)]);
      coco=(mempos >> 16);
      if (coco==0x1f00) return(PAR[mempos&0xffff]);
      if (coco==0x1f80) return(hread_byte(mempos & 0xffff));

      printf("%8.8x: There is no memory at %8.8x ! (byte)\n",ctx.pc0,mempos);
      return(0);
}

sint16 rm_16s(uint32 mempos) {
      int unsigned coco;
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) return(END_16(SRAOM16[(mempos&0x1fffff)>>1]));
      if (coco==0xbf) return(END_16(SRAOM16[(0x200000+ (mempos&0x07ffff))>>1]));
      coco=(mempos >> 16);
      if (coco==0x1f00) return(END_16(SPAR16[(mempos&0xffff)>>1]));
      if (coco==0x1f80) return(hread_word(mempos & 0xffff));

      printf("%8.8x: There is no memory at %8.8x ! (s_half)\n",ctx.pc0,mempos);
      return(0);
}

uint16 rm_16u(uint32 mempos) {
      int unsigned coco;
      if ((mempos&0x1ffffc)==ctx.pbuf) get_pad_buf();
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) return(END_16(RAOM16[(mempos&0x1fffff)>>1]));
      if (coco==0xbf) return(END_16(RAOM16[(0x200000+(mempos&0x07ffff))>>1]));
      coco=(mempos >> 16);
      if (coco==0x1f00) return(END_16(PAR16[(mempos&0xffff)>>1]));
      if (coco==0x1f80) return(hread_word(mempos & 0xffff));

      printf("%8.8x: There is no memory at %8.8x ! (half)\n",ctx.pc0,mempos);
      return(0);
}

uint32 rm_32(uint32 mempos) {
      int unsigned coco;
      if ((mempos&0x1ffffc)==ctx.pbuf) get_pad_buf();
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) return (END_32(RAOM32[(mempos&0x1fffff)>>2]));
      if (coco==0xbf) return (END_32(RAOM32[(0x200000+(mempos&0x07ffff))>>2]));
      coco=(mempos >> 16);
      if (coco==0x1f00) return (END_32(PAR32[(mempos&0xffff)>>2]));
      if (coco==0x1f80) return (hread(mempos & 0xffff));

      printf("%8.8x: There is no memory at %8.8x ! (word)\n",ctx.pc0,mempos);
      return(0);
}

void wm_8(uint8 af,uint32 mempos)
{
      int unsigned coco;
      if ((ctx.cp0[12]&0x10000)!=0) return;
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) {
            RAOM[mempos&0x1fffff]=af;
            return;
      }
      coco=(mempos >> 16);
      if (coco==0x1f80) {
            hwrite_byte(af,mempos & 0xffff);
            return;
      }
      if (coco==0x1f00) PAR[mempos&0xffff]=af;
}

void wm_16(uint16 af,uint32 mempos)
{
      int unsigned coco;

      if ((ctx.cp0[12]&0x10000)!=0) return;
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) {
            RAOM16[(mempos&0x1fffff)>>1]=END_16(af);
            return;
      }
      coco=(mempos >> 16);
      if (coco==0x1f80) {
            hwrite_word(af,mempos & 0xffff);
            return;
      }
      if (coco==0x1f00) PAR16[(mempos&0xffff)>>1]=END_16(af);
}

void wm_32(uint32 af,uint32 mempos)
{
      int unsigned coco;

      if ((ctx.cp0[12]&0x10000)!=0) return;
      coco=(mempos >> 24);
      if ((coco==0x00) || (coco==0x80) || (coco==0xa0)) {
            RAOM32[(mempos&0x1fffff)>>2]=END_32(af);
            return;
      }
      coco=(mempos >> 16);
      if (coco==0x1f80) {
            hwrite(af,mempos & 0xffff);
            return;
      }
      if (coco==0x1f00) PAR32[(mempos&0xffff)>>2]=END_32(af);
}
