#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <dlfcn.h>

#include "sope.h"
#include "gui.h"
#include "plugins.h"
#include "renderer.h"
#include "sound.h"

char *plugins_path_renderer = "plugins/Renderer";
char *plugins_path_sound = "plugins/Sound";
char *getinfo_renderer = "get_renderer_info";
char *getinfo_sound = "get_sound_info";

#define DEFINE_LIST_PLUGINS(Type,type)\
void list_##type##_plugins(void (*fonc)()) {\
	DIR *dir;\
	struct dirent *ent;\
	void *h = NULL;\
	void *(*rdi)(void);\
	char filename[256];\
\
    dir = opendir(plugins_path_##type);\
    if (dir) {\
        while ((ent = readdir(dir)) != NULL) {\
            sprintf(filename,"%s/%s",plugins_path_##type,ent->d_name);\
            if (strstr(filename,".so") != NULL) {\
                if ((h = dlopen(filename, RTLD_NOW )) != NULL) {\
                    if ((rdi = dlsym(h, getinfo_##type)) != NULL) {\
                        ##Type *r;\
\
                        r = (##Type *) rdi();\
                        (*fonc)(ent->d_name,r->description);\
                    }\
                    else\
                    {\
                        (*fonc)(ent->d_name,"Not a valid plugin");\
                    }\
                    dlclose(h);\
                }\
                else\
                {\
                    sprintf(filename,"%s",dlerror());\
                    (*fonc)(ent->d_name,filename);\
                }\
            }\
        }\
    }\
}

#define DEFINE_LOAD_PLUGIN(Type,type,var)\
int load_##type##_plugin(char *filename,char *result) {\
    void *(*rdi)();\
    static void *h = NULL;\
    char full_filename[256];\
\
    sprintf(full_filename,"%s/%s",plugins_path_##type,filename);\
\
    if (h!=NULL)\
        dlclose(h);\
    if ((h = dlopen(full_filename, RTLD_NOW)) != NULL) {\
        if ((rdi = dlsym(h, getinfo_##type)) != NULL) {\
            var = (##Type *) rdi();\
            sprintf(result,"%s",var->description);\
            return(1);\
        } else {\
            sprintf(result,"Not a valid plugin");\
            dlclose(h);\
            h=NULL;\
			var=NULL;\
            return(0);\
        }\
    } else {\
        sprintf(result,"%s",dlerror());\
		var=NULL;\
        return(0);\
    }\
}

DEFINE_LIST_PLUGINS(Renderer, renderer)
DEFINE_LIST_PLUGINS(Sound, sound)

DEFINE_LOAD_PLUGIN(Renderer, renderer, rnd)
DEFINE_LOAD_PLUGIN(Sound, sound, snd)
