#ifndef RENDERER_H
#define RENDERER_H

#include "gpu_types.h"
#include "plugins.h"

typedef struct {
	char *description;/*The character ":" is forbidden*/
	Config_List *config_list;
	void (*start)(gpu_state *gs,uint32 *vram);
	void (*init)();
	void (*exit)();
	void (*open_window)(unsigned int w,unsigned int h);
	void (*close_window)();
	void (*FSline)(fs_line *prim);
	void (*GSline)(gs_line *prim);
	void (*FSpoly3)(fs_triangle *prim);
	void (*GSpoly3)(gs_triangle *prim);
	void (*FSpoly4)(fs_quadrangle *prim);
	void (*GSpoly4)(gs_quadrangle *prim);
	void (*FSTpoly3)(fst_triangle *prim);
	void (*GSTpoly3)(gst_triangle *prim);
	void (*FSTpoly4)(fst_quadrangle *prim);
	void (*GSTpoly4)(gst_quadrangle *prim);
	
	void (*render_sprite)(sprite *prim);
	void (*blockfill)(block *prim);
	void (*rectangle)(block *prim);
	
	void (*clear_texture_cache)();
	void (*render_frame)();
	void (*set_scissor)();
	void (*set_blending)();
	void (*change_title)();

	int  (*key_pressed)();
	uint16 (*get_key)();
} Renderer;

Renderer *rnd;

#endif
