#include "opengl.h"
#include "vram_macros.h"

uint32 mimi(uint32 c) {
	uint32 d;
	d=(c&0x00ffffff);
	if (d!=0) d|=0xff000000;
	return(d);
}

void ogl_clear_texture_cache(){
	_texx=0xffff;
	_texy=0xffff;
}

void load_texture(texture *tex,int m){
	int i,j,k;
	uint32 cc[256];
	uint32 e;
	uint8 t;

	tw64=256;th64=256;
	printf("%d %d %d\n",_texx,_texy,_tx_pal);
	if ((_texx==tex->texx) && (_texy==tex->texy) && (_tx_pal==tex->tx_pal)) return;
	_texx=tex->texx;
	_texy=tex->texy;
	_tx_pal=tex->tx_pal;
	switch(_tx_pal) {
		case 0:/*16 colors palette*/
			for (i=0;i<16;i++) cc[i]=mimi(glbuf[tex->cluy*1024+tex->clux+i]);
			for (j=0;j<th64;j++) {
				k=j*tw64;
				for (i=0;i<tw64;i++) {
					t=vram4((_texy+j)*4096+_texx*4+i);
					txt[k]=cc[t];
					k++;
				}
			}	  
			break;
		case 1: /*256 colors palette*/
			for (i=0;i<256;i++) cc[i]=mimi(glbuf[tex->cluy*1024+tex->clux+i]);
			for (j=0;j<th64;j++) {
				k=j*tw64;	
				for (i=0;i<tw64;i++) {
					t=vram8((_texy+j)*2048+_texx*2+i);
					txt[k]=cc[t];
					k++;
				}
			}
			break;
		case 2:/*No color palette*/
			for (j=0;j<th64;j++) {
				k=j*tw64;	
				for (i=0;i<tw64;i++) {
					e=mimi(glbuf[(_texy+j)*1024+_texx+i]);
					txt[k]=e;
					k++;
				}
			}
			break;
	}
	glTexImage2D(GL_TEXTURE_2D,0,4,tw64,th64,0,GL_RGBA,GL_UNSIGNED_BYTE,txt);
	if (anti_alias==1) {
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	} else {
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	}
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_R,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
	glEnable(GL_TEXTURE_2D);
	if (m==0)	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	else		glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_FASTEST);
}

