#include <SDL/SDL.h>
#include <string.h>
#include <ctype.h>
#include "soft.h"
#include "keyboard.h"

SDL_Surface *screen,*tm,*fm;
int cur_width,cur_height;

static int dsp_init();
static void dsp_exit();
static void dsp_open_window(unsigned int w,unsigned int h);
static void dsp_close_window();
static void dsp_change_title(char *title);
static void dsp_render_frame(uint32 *image,int start,int endw);
static int dsp_key_pressed();
static uint16 dsp_get_key();


DisplayStruct Dsp_SDL = {
	dsp_init,
	dsp_exit,
	dsp_open_window,
	dsp_close_window,
	dsp_change_title,
	dsp_render_frame,
	dsp_key_pressed,
	dsp_get_key
};

static int dsp_init() {
	gps->oxi=0;gps->oyi=0;gps->oxf=1024;gps->oyf=512;
	if (SDL_Init(SDL_INIT_VIDEO)==-1) return -1;
	SDL_EnableKeyRepeat(0,0);
	return 0;
}

static void dsp_open_window(unsigned int w,unsigned int h) {
//	screen=SDL_SetVideoMode(w,h,32,0);
	screen=SDL_SetVideoMode(w,h,0,0);
	cur_width=w;
	cur_height=h;
}
static void dsp_close_window() {
	SDL_FreeSurface(screen);
}

static void dsp_exit() {
	SDL_FreeSurface(screen);
}
static void dsp_change_title(char *title) {
	SDL_WM_SetCaption(title,title);
}

static void dsp_render_frame(uint32 *image,int start,int endw) {
	fm=SDL_CreateRGBSurfaceFrom(image+start,cur_width,cur_height,32,endw*4,0xFF,0x00FF00,0XFF0000,0xFF000000);
	tm=SDL_DisplayFormat(fm);
	SDL_BlitSurface(tm,NULL,screen,NULL);
	SDL_FreeSurface(tm);
	SDL_FreeSurface(fm);
	SDL_UpdateRect(screen,0,0,cur_width,cur_height);

}
SDL_Event E;

static int dsp_key_pressed() {
	SDL_PollEvent(&E);
	if (E.type==SDL_KEYDOWN) return PRESSED_KEY;
	if (E.type==SDL_KEYUP) return RELEASED_KEY;
	return NO_KEY;
}

static uint16 dsp_get_key() {

	uint16 key;

	key=E.key.keysym.sym;
	return(key);
/*	switch (key) {
		case SDLK_SPACE:
			return KEY_SPACE;
		case SDLK_UP:
			return KEY_UP;
		case SDLK_DOWN:
			return KEY_DOWN;
		case SDLK_RIGHT:
			return KEY_RIGHT;
		case SDLK_LEFT:
			return KEY_LEFT;
		default:
			if (!isalpha(key))
				return KEY_INVALID;
			return key;
	}
*/
}
