#include "sope.h"
#include "renderer.h"
#include "vram.h"

typedef struct DisplayStruct {
    int (*init)();
    void (*exit)();
    void (*open_window)(unsigned int w,unsigned int h);
    void (*close_window)();
    void (*change_title)(char *title);
    void (*render_frame)(uint32 *image, int start, int endw);
    int (*key_pressed)();
    uint16 (*get_key)();
} DisplayStruct;

void draw_sumcol(uint16 x,uint16 y,int p,uint32 c2);
uint32 moco(uint32 cc,uint32 c);
void sd_line(short int *xa,short int *ya,uint32 *c,int gourP,int blendP);

/*Triangles*/
void sdf_triangle(sint16 *xa,sint16 *ya,int p0,int p1,int p2,int blendP,uint32 *colors);
void sdg_triangle(sint16 *xa,sint16 *ya,int p0,int p1,int p2,int blendP,uint32 *colors);
void sdft_triangle(sint16 *xa,sint16 *ya,int p0,int p1,int p2,int blendP,uint32 *colors,int mocoP,texture *tex);
void sdgt_triangle(sint16 *xa,sint16 *ya,int p0,int p1,int p2,int blendP,uint32 *colors,int mocoP,texture *tex);

void sd_initcc(texture *tex,int m,uint32 c);

void soft_FSline(fs_line *prim);
void soft_GSline(gs_line *prim);
void soft_FSpoly3(fs_triangle *prim);
void soft_GSpoly3(gs_triangle *prim);
void soft_FSpoly4(fs_quadrangle *prim);
void soft_GSpoly4(gs_quadrangle *prim);
void soft_FSTpoly3(fst_triangle *prim);
void soft_GSTpoly3(gst_triangle *prim);
void soft_FSTpoly4(fst_quadrangle *prim);
void soft_GSTpoly4(gst_quadrangle *prim);

void soft_render_sprite(sprite *prim);
void soft_blockfill(block *prim);
void soft_rectangle(block *prim);

void soft_start(gpu_state *gs,uint32 *vr);
void soft_open_window(unsigned int w,unsigned int h);
void soft_close_window();
void soft_init();
void soft_exit();
void soft_clear_texture_cache();
void soft_render_frame();
void soft_set_scissor();
void soft_set_blending();
void soft_change_title();
int soft_key_pressed();
uint16 soft_get_key();
void soft_scale(uint32 *src, int sw, int sh,
		uint32 *dst, int dw, int dh);
gpu_state *gps;
uint32 *vram;
#define km_s	512		/* keymap size */