#include "soft.h"
#include "vram_macros.h"

void soft_render_sprite(sprite *prim) {
	uint16 u,v;
	uint16 clux,cluy;
	uint16 texx,texy;
	sint16 x,y,w,h;
	uint32 mococ;
	int unsigned txi,txf,tyi,tyf;
	int unsigned i,j;
	uint32 cc[256];
	int unsigned e;
	char unsigned d;
	int m,p;

	mococ=prim->c&0xffffff;
	m=prim->m;			p=prim->t;
	x=prim->x;			y=prim->y;
	w=prim->w;			h=prim->h;
	u=prim->tex.u[0];	v=prim->tex.v[0];
	clux=prim->tex.clux;cluy=prim->tex.cluy;
	texx=prim->tex.texx;texy=prim->tex.texy;

	if ((y<(1+gps->oyi-h)) || (x<(1+gps->oxi-w)) || (y>(gps->oyf-1)) || (x>(gps->oxf-1))) return;
	txi=0;txf=w;tyi=0;tyf=h;
	if (y<gps->oyi) tyi=gps->oyi-y;
	if (y>(gps->oyf-h)) tyf=h-(y-(gps->oyf-h));
	if (x<gps->oxi) txi=gps->oxi-x;
	if (x>(gps->oxf-w)) txf=w-(x-(gps->oxf-w));

	if (prim->tex.tx_pal==2) {/*No palette*/
		for (j=tyi;j<tyf;j++) {
			for (i=txi;i<txf;i++) { 
				if (m)	e=vram[(texy+j+v)*1024+texx+u+i];
				else	e=moco(vram[(texy+j+v)*1024+texx+u+i],mococ);
				draw_sumcol(x+i,y+j,p,e);
			}
		}
	return;
	}

	if (m)
		for (i=0;i<(16+240*prim->tex.tx_pal);i++)
			cc[i]=vram[cluy*1024+clux+i];
	else
		for (i=0;i<(16+240*prim->tex.tx_pal);i++)
			cc[i]=moco(vram[cluy*1024+clux+i],mococ);

	if (prim->tex.tx_pal==0) {/*16 colors palette*/
		for (j=tyi;j<tyf;j++) {
			for (i=txi;i<txf;i++) {
				d=vram4((texy+v+j)*4096+texx*4+u+i);
				draw_sumcol(x+i,y+j,p,cc[d]);
			}
		}
	}

	if (prim->tex.tx_pal==1) {/*256 colors palette*/
		for (j=tyi;j<tyf;j++) {
			for (i=txi;i<txf;i++) { 
				d=vram8((texy+j+v)*2048+texx*2+u+i);
				draw_sumcol(x+i,y+j,p,cc[d]);
			}
		}
	}
}

