#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <unistd.h>
#include "sope.h"
#include "sound.h"
#include "oss.h"

Config_List oss_config_list = {0,NULL};
Sound oss_sound = {
	"OSS sound plugin",
	&oss_config_list,
	oss_init,
	oss_exit,
	oss_play_sample
};

Sound *get_sound_info()
{
	return &oss_sound;
}

static int audio_fd;

int oss_init()
{
	int i;
	audio_buf_info info;
	if ((audio_fd = open("/dev/dsp", O_WRONLY)) == -1)
		return 0;
	else
		printf("# Sope # OSS driver initialized\n");

	i = (1 << 16 | 9);
	ioctl(audio_fd, SNDCTL_DSP_SETFRAGMENT, &i);
	ioctl(audio_fd, SNDCTL_DSP_GETOSPACE, &info);

	i = AFMT_S16_LE;
	ioctl(audio_fd, SNDCTL_DSP_SETFMT, &i);
	i = 0;
	ioctl(audio_fd, SNDCTL_DSP_STEREO, &i);
	i = 44100;
	ioctl(audio_fd, SNDCTL_DSP_SPEED, &i);
	return 1;
}

void oss_exit()
{
	ioctl(audio_fd, SNDCTL_DSP_SYNC);
	close(audio_fd);
}

void set_frequency(int fq)
{
	int i;
	printf("setting frequency at %u\n", fq);
	i = fq;
	ioctl(audio_fd, SNDCTL_DSP_SPEED, &i);
}

void oss_play_sample(sint16 * buff, int taille)
{
	int i, j;
	sint16 *b;

	i = taille * 2;
	b = buff;
	j = write(audio_fd, b, i);
}
