#include <string.h>
#include <stdlib.h>
#include "sope.h"
#include "gui.h"

#define v0 ctx.gpr[2]
#define a0 ctx.gpr[4]
#define a1 ctx.gpr[5]
#define a2 ctx.gpr[6]
#define a3 ctx.gpr[7]
#define ra ctx.gpr[31]

#define Ra0 getaddr(a0)
#define Ra1 getaddr(a1)
#define Ra2 getaddr(a2)
#define Ra3 getaddr(a3)

char *A0SysCalls[]={
// 0x00
"open","lseek","read","write",
"close","ioctl","exit","sys_a0_07",
"getc","putc","todigit","atof",
"strtoul","strtol","abs","labs",
// 0x10
"atoi","atol","atob","setjmp",
"longjmp","strcat","strncat","strcmp",
"strncmp","strcpy","strncpy","strlen",
"index","rindex","strchr","strrchr",
// 0x20
"strpbrk","strspn","strcspn","strtok",
"strstr","toupper","tolower","bcopy",
"bzero","bcmp","memcpy","memset",
"memmove","memcmp","memchr","rand",
// 0x30
"srand","qsort","strtod","malloc",
"free","lsearch","bsearch","calloc",
"realloc","InitHeap","_exit","getchar",
"putchar","gets","puts","printf",
// 0x40
"sys_a0_40","LoadTest","Load","Exec",
"FlushCache","InstallInterruptHandler","GPU_dw","mem2vram",
"SendGPUStatus","GPU_cw","GPU_cwb","SendPackets",
"sys_a0_4c","GetGPUStatus","GPU_sync","sys_a0_4f",
// 0x50
"sys_a0_50","LoadExec","GetSysSp","sys_a0_53",
"_96_init()","_bu_init()","_96_remove()","sys_a0_57",
"sys_a0_58","sys_a0_59","sys_a0_5a","dev_tty_init",
"dev_tty_open","sys_a0_5d","dev_tty_ioctl","dev_cd_open",
// 0x60
"dev_cd_read","dev_cd_close","dev_cd_firstfile","dev_cd_nextfile",
"dev_cd_chdir","dev_card_open","dev_card_read","dev_card_write",
"dev_card_close","dev_card_firstfile","dev_card_nextfile","dev_card_erase",
"dev_card_undelete","dev_card_format","dev_card_rename","dev_card_6f",
// 0x70
"_bu_init","_96_init","_96_remove","sys_a0_73",
"sys_a0_74","sys_a0_75","sys_a0_76","sys_a0_77",
"_96_CdSeekL","sys_a0_79","sys_a0_7a","sys_a0_7b",
"_96_CdGetStatus","sys_a0_7d","_96_CdRead","sys_a0_7f",
// 0x80
"sys_a0_80","sys_a0_81","sys_a0_82","sys_a0_83",
"sys_a0_84","_96_CdStop","sys_a0_86","sys_a0_87",
"sys_a0_88","sys_a0_89","sys_a0_8a","sys_a0_8b",
"sys_a0_8c","sys_a0_8d","sys_a0_8e","sys_a0_8f",
// 0x90
"sys_a0_90","sys_a0_91","sys_a0_92","sys_a0_93",
"sys_a0_94","sys_a0_95","AddCDROMDevice","AddMemCardDevide",
"DisableKernelIORedirection","EnableKernelIORedirection","sys_a0_9a","sys_a0_9b",
"SetConf","GetConf","sys_a0_9e","SetMem",
// 0xa0
"_boot","SystemError","EnqueueCdIntr","DequeueCdIntr",
"sys_a0_a4","ReadSector","get_cd_status","bufs_cb_0",
"bufs_cb_1","bufs_cb_2","bufs_cb_3","_card_info",
"_card_load","_card_auto","bufs_cd_4","sys_a0_af",
// 0xb0
"sys_a0_b0","sys_a0_b1","do_a_long_jmp","sys_a0_b3",
"?? sub_function"/*,"","","",
"","","","",
"","","","",*/
};
char *B0SysCalls[]={
// 0x00
"SysMalloc","sys_b0_01","sys_b0_02","sys_b0_03",
"sys_b0_04","sys_b0_05","sys_b0_06","DeliverEvent",
"OpenEvent","CloseEvent","WaitEvent","TestEvent",
"EnableEvent","DisableEvent","OpenTh","CloseTh",
// 0x10
"ChangeTh","sys_b0_11","InitPAD","StartPAD",
"StopPAD","PAD_init","PAD_dr","ReturnFromExecption",
"ResetEntryInt","HookEntryInt","sys_b0_1a","sys_b0_1b",
"sys_b0_1c","sys_b0_1d","sys_b0_1e","sys_b0_1f",
// 0x20
"UnDeliverEvent","sys_b0_21","sys_b0_22","sys_b0_23",
"sys_b0_24","sys_b0_25","sys_b0_26","sys_b0_27",
"sys_b0_28","sys_b0_29","sys_b0_2a","sys_b0_2b",
"sys_b0_2c","sys_b0_2d","sys_b0_2e","sys_b0_2f",
// 0x30
"sys_b0_30","sys_b0_31","open","lseek",
"read","write","close","ioctl",
"exit","sys_b0_39","getc","putc",
"getchar","putchar","gets","puts",
// 0x40
"cd","format","firstfile","nextfile",
"rename","delete","undelete","AddDevice",
"RemoteDevice","PrintInstalledDevices","InitCARD","StartCARD",
"StopCARD","sys_b0_4d","_card_write","_card_read",
// 0x50
"_new_card","Krom2RawAdd","sys_b0_52","sys_b0_53",
"_get_errno","_get_error","GetC0Table","GetB0Table",
"_card_chan","sys_b0_59","sys_b0_5a","ChangeClearPAD",
"_card_status","_card_wait"/*,"","",*/
};
char *C0SysCalls[]={
// 0x00
"InitRCnt","InitException","SysEnqIntRP","SysDeqIntRP",
"get_free_EvCB_slot","get_free_TCB_slot","ExceptionHandler","InstallExeptionHandler",
"SysInitMemory","SysInitKMem","ChangeClearRCnt","SystemError",
"InitDefInt","sys_c0_0d","sys_c0_0e","sys_c0_0f",
// 0x10
"sys_c0_10","sys_c0_11","InstallDevices","FlushStfInOutPut",
"sys_c0_14","_cdevinput","_cdevscan","_circgetc",
"_circputc","ioabort","sys_c0_1a","KernelRedirect",
"PatchAOTable"/*,"","","",*/
};


void syscall_a0(uint32 arg) {
	switch(arg) {
/*	case 0x17:	// int strcmp (char *s1,char *s2)
			if (debug_syscall) printf("strcmp %8.8x %8.8x\n",a0,a1);
			v0 = strcmp(Ra0,Ra1);
			ctx.pc0=ra;
			return;
	case 0x18:	// int strncmp (char *s1,char *s2,int n)
//			printf ("strncmp(%s,%s,%d)\n",Ra0,Ra1,a2);
			v0 = strncmp (Ra0,Ra1,a2);
			ctx.pc0 = ra;
	//		v0 = 0;
			return;*/
/*	case 0x2a:	//void *memcpy (uchar *dest,uchar *src, int n)
			return;*/
	case 0x2f:	//int rand (void) // RAND_MAX == 32767
			v0 = 1+(int) (32767.0*rand()/(RAND_MAX+1.0));
			ctx.pc0 = ra;
			return;
	case 0x3a:	// void _exit (void)
			ciao("Quit by syscall: _exit");
//	case 0x3f:
//			printf ("%s",Ra0);
//			ctx.pc0 = ra;
	}
	if (debug_syscall) printf("# Sope # Syscall A0_%2.2x (%s)\n",arg,A0SysCalls[arg]);
}

void syscall_b0(uint32 arg) {

	switch(arg) {
	case 0x07:	
		if (debug_syscall) printf("DeliverEvent(%8.8x,%u)\n",a0,a1);
		return;
	case 0x08:	
		if (debug_syscall) printf("OpenEvent(%8.8x,%x,%x,%8.8x)\n",a0,a1,a2,a3);
		return;
	case 0x09:	if (debug_syscall) printf("CloseEvent(%u)\n",a0);return;
	case 0x0a:  if (debug_syscall) printf("WaitEvent(%u)\n",a0);return;
	case 0x0b:	// long TestEvent (ulong ev)
			v0 = 1;
			ctx.pc0 = ra;
			return;	
	case 0x0c:  if (debug_syscall) printf("EnableEvent(%8.8x)\n",a0);return;
	case 0x0d:  if (debug_syscall) printf("DisableEvent(%u)\n",a0);return;
/*Quick and dirty Pad Hack*/
	case 0x12:	ctx.pbuf=a0&0x1fffff;pad_init=2;break;
	case 0x15:	ctx.pbuf=a1&0x1fffff;pad_init=1;break;
	case 0x17:	return;
	case 0x3d:  gui->PSX_printchar(a0);
				ctx.pc0=ra;
				return;
	case 0x3f:	gui->PSX_printstring(Ra0);
				ctx.pc0=ra;
				return;
	case 0x4f:	if (debug_syscall) printf("# Sope # CARD READ\n");break;
	}
	if (debug_syscall) printf("# Sope # Syscall B0_%2.2x (%s) %8.8x %8.8x %8.8x\n",arg,B0SysCalls[arg],a0,a1,a2);
}

void syscall_c0(uint32 arg) {
/*	switch(arg) {
	}*/
	if (debug_syscall) printf("# Sope # Syscall C0_%2.2x (%s)\n",arg,C0SysCalls[arg]);
}
