#include "sope.h"
#include "vram.h"

/*transform a 32-bit GL word into a 16-bit VRAM short*/
uint16 tthi(uint32 cc) {
    uint32 r,g,b,a;
    uint16 d;
    r=(cc>>3)&0x1f;
    g=(cc>>11)&0x1f;
    b=(cc>>19)&0x1f;
    a=(cc>>24)&1;
    d=r+0x20*g+0x400*b+0x8000*a;
    return(d);
}
/*transform a 16-bit VRAM short into a 32-bit GL word*/
uint32 hitt(uint16 cc) {
    short unsigned r,g,b,a;
    uint32 d;
    r=cc&0x1f;
    g=(cc>>5)&0x1f;
    b=(cc>>10)&0x1f;
    a=(cc>>15)&1;
    d=0x8*r+0x800*g+0x80000*b+0xff000000*a;
    return(d);
}
/* access to 32-bit stuff in vram*/
uint32 vram32(unsigned int vpos) {
    short unsigned c;
    int unsigned d;
    if (vpos>0x40000) return(0);
    c=tthi(glbuf[vpos*2]);
    d=c;
    c=tthi(glbuf[vpos*2+1]);
    d+=0x10000*c;
    return(d);
}

